      subroutine mg5_for_mcfm
      
      implicit none
      
      double precision qmass(1:2),bmass(1:3)
     & ,widths(1:4),sminputs(1:3),yukawas(2)
      common/mg5_trsf/qmass,bmass,widths,sminputs,yukawas
      double precision YMQ(2)
      logical yukawas_on,bottom,top
      common/c_yuk/YMQ,yukawas_on,bottom,top
     
      include 'ewinput.f'
      include 'masses.f'
      include 'nflav.f'
      include 'nores.f'
      
c     --------------
c     | BEGIN CODE |
c     --------------

c----- SM inputs
      Gf_inp = sminputs(1)            ! G_F
      aemmz_inp = sminputs(2)    ! alpha_EM(m_Z)=1/128.89
      xw_inp = sminputs(3)               ! sin^2(theta_W)
      wmass_inp = bmass(2)
      zmass_inp = bmass(3)      

    
      nflav = 5
      nores = .false.
      
c----- leptons
      mel  = 0.510997d-3
      mmu  = 0.105658389d0
      mtau = 1.777d0
      mtausq = mtau**2
      tauwidth = 2.269d-12
      
c----- quarks
      mu = 5d-3
      md = 5d-3
      mc = 1.5d0
      ms = 1d-1
      mt = qmass(2)
      mb = qmass(1)
      
      twidth = widths(4)
      
c----- bosons
      hmass = bmass(1)
      
      hwidth = widths(1)
      wwidth = widths(2)
      zwidth = widths(3)
     
c----- check yukawas
      if (yukawas(1) .lt. 0.1D0 .and. yukawas(2) .lt. 0.1D0) then

        yukawas_on = .false.
        bottom = .false.
        top = .false.
        YMQ(1)=0.D0
        YMQ(2)=0.D0
        write(*,*) '*****************************************'
        write(*,*) '**   Yukawa couplings are too small.   **'
        write(*,*) '**   They are set to zero.             **'
        write(*,*) '**   YMB = ',YMQ(1),' **'
        write(*,*) '**   YMT = ',YMQ(2),' **'
        write(*,*) '*****************************************'

      elseif (yukawas(1) .lt. 0.1D0 .and. yukawas(2) .gt. 0.1D0) then

        bottom=.false.
        top=.true.
        yukawas_on = .true.
        YMQ(1)=yukawas(1)
        YMQ(2)=yukawas(2)
        write(*,*) '*****************************************'
        write(*,*) '**   Yukawa couplings are set to       **'
        write(*,*) '**   YMB = ',YMQ(1),' **'
        write(*,*) '**   YMT = ',YMQ(2),' **'
        write(*,*) '*****************************************'        

      elseif (yukawas(1) .gt. 0.1D0 .and. yukawas(2) .lt. 0.1D0) then

        bottom=.true.
        top=.false.
        yukawas_on = .true.
        YMQ(1)=yukawas(1)
        YMQ(2)=yukawas(2)
        write(*,*) '*****************************************'
        write(*,*) '**   Yukawa couplings are set to       **'
        write(*,*) '**   YMB = ',YMQ(1),' **'
        write(*,*) '**   YMT = ',YMQ(2),' **'
        write(*,*) '*****************************************'

      elseif (yukawas(1) .gt. 0.1D0 .and. yukawas(2) .gt. 0.1D0) then

        bottom=.true.
        top=.true.
        yukawas_on = .true.
        YMQ(1)=yukawas(1)
        YMQ(2)=yukawas(2)
        write(*,*) '*****************************************'
        write(*,*) '**   Yukawa couplings are set to       **'
        write(*,*) '**   YMB = ',YMQ(1),' **'
        write(*,*) '**   YMT = ',YMQ(2),' **'
        write(*,*) '*****************************************'


      endif

      return
      end
