      DOUBLE PRECISION FUNCTION DSIG1(PP,WGT,IMODE)
C     ****************************************************
C     
C     Generated by MadGraph 5 v. 1.3.28, 2011-11-14
C     By the MadGraph Development Team
C     Please visit us at https://launchpad.net/madgraph5
C     
C     Process: u u~ > e+ e- mu+ mu- / e- mu- WEIGHTED=8
C     
C     RETURNS DIFFERENTIAL CROSS SECTION
C     Input:
C     pp    4 momentum of external particles
C     wgt   weight from Monte Carlo
C     imode 0 run, 1 init, 2 reweight, 
C     3 finalize, 4 only PDFs
C     Output:
C     Amplitude squared and summed
C     ****************************************************
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INCLUDE 'genps.inc'
      INCLUDE 'nexternal.inc'
      INCLUDE 'maxamps.inc'
      DOUBLE PRECISION       CONV
      PARAMETER (CONV=389379.66*1000)  !CONV TO PICOBARNS
      REAL*8     PI
      PARAMETER (PI=3.1415926D0)
C     
C     ARGUMENTS 
C     
      DOUBLE PRECISION PP(0:3,NEXTERNAL), WGT
      INTEGER IMODE
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,ITYPE,LP
      DOUBLE PRECISION U1,UB1,D1,DB1,C1,CB1,S1,SB1,B1,BB1
      DOUBLE PRECISION U2,UB2,D2,DB2,C2,CB2,S2,SB2,B2,BB2
      DOUBLE PRECISION G1,G2
      DOUBLE PRECISION A1,A2
      DOUBLE PRECISION XPQ(-7:7)
      DOUBLE PRECISION DSIGUU
C     
C     EXTERNAL FUNCTIONS
C     
      LOGICAL PASSCUTS
      DOUBLE PRECISION ALPHAS2,REWGT,PDG2PDF
C     
C     GLOBAL VARIABLES
C     
      INTEGER              IPROC
      DOUBLE PRECISION PD(0:MAXPROC)
      COMMON /SUBPROC/ PD, IPROC

      INTEGER SUBDIAG(MAXSPROC),IB(2)
      COMMON/TO_SUB_DIAG/SUBDIAG,IB
      INCLUDE 'coupl.inc'
      INCLUDE 'run.inc'
C     
C     DATA
C     
      DATA U1,UB1,D1,DB1,C1,CB1,S1,SB1,B1,BB1/10*1D0/
      DATA U2,UB2,D2,DB2,C2,CB2,S2,SB2,B2,BB2/10*1D0/
      DATA A1,G1/2*1D0/
      DATA A2,G2/2*1D0/

      DOUBLE PRECISION MIJ,m12,m34

      !antoine
      double precision mat2
      logical wmat2  
      common/antoine/mat2,wmat2

C     ----------
C     BEGIN CODE
C     ----------
      DSIG1=0D0
      wmat2=.false.
C     Only run if IMODE is 0
      IF(IMODE.NE.0.AND.IMODE.NE.4) RETURN


      IF (ABS(LPP(IB(1))).GE.1) THEN
        LP=SIGN(1,LPP(IB(1)))
        LP=0
        U1=PDG2PDF(ABS(LPP(IB(1))),2*LP,XBK(IB(1)),DSQRT(Q2FACT(1)))
      ENDIF
      IF (ABS(LPP(IB(2))).GE.1) THEN
        LP=SIGN(1,LPP(IB(2)))
        LP=0
        UB2=PDG2PDF(ABS(LPP(IB(2))),-2*LP,XBK(IB(2)),DSQRT(Q2FACT(2)))
      ENDIF
      PD(0) = 0D0
      IPROC = 0
      IPROC=IPROC+1  ! u u~ > e+ e- mu+ mu-
      PD(IPROC)=PD(IPROC-1) + U1*UB2/2.D0
      IF (IMODE.EQ.4)THEN
        DSIG1 = PD(IPROC)
        RETURN
      ENDIF

c      IF (ABS(mij(pp,3,4)-91.1876D0) .lt. ABS(mij(pp,5,6)-91.1876D0)) THEN
c       m12=mij(pp,3,4)
c       m34=mij(pp,5,6)
c      ELSE
c       m12=mij(pp,5,6)
c       m34=mij(pp,3,4)
c      ENDIF

c      IF (abs(mij(pp,1,2)-125.D0) .lt. 1.D0
c     & .and.
c     &    m12 .gt. 76.D0 .and. m12 .lt. 106.D0 .and.
c     &    m34 .gt. 15.D0 .and. m34 .lt. 115.D0
c     &   ) THEN 

      CALL SMATRIX1(PP,DSIGUU)

c      ELSE

c      DSIGUU = 0.D0
 
c      ENDIF

      DSIGUU=DSIGUU*REWGT(PP)
      IF (DSIGUU.LT.1D199) THEN
        DSIG1=PD(IPROC)*CONV*DSIGUU
      ELSE
        WRITE(*,*) 'Error in matrix element'
        DSIGUU=0D0
        DSIG1=0D0
      ENDIF
      IF(IMODE.EQ.0.AND.DSIG1.GT.0D0)THEN
C       Call UNWGT to unweight and store events
        wmat2=.true.
        CALL UNWGT(PP,DSIG1*WGT,1)
      ENDIF

      END

      DOUBLE PRECISION FUNCTION MIJ(P,I,J)

      IMPLICIT NONE

      INCLUDE "nexternal.inc"

      DOUBLE PRECISION P(0:3,NEXTERNAL)
      INTEGER I,J

      MIJ = SQRT(
     & (P(0,I)+P(0,J))**2 -
     & (P(1,I)+P(1,J))**2 -
     & (P(2,I)+P(2,J))**2 -
     & (P(3,I)+P(3,J))**2
     & )

      RETURN
      END
