      SUBROUTINE CTLOOP(NLOOPLINE,PL,M2L,RANK,RES)
C     
C     Generated by MadGraph 5 v. 1.4.3, 2012-03-08
C     By the MadGraph Development Team
C     Please visit us at https://launchpad.net/madgraph5
C     
C     Interface between MG5 and CutTools.
C     
C     Process: g g > e+ e- mu+ mu- [ QCD ] WEIGHTED=20 / e- mu-
C     
C     
C     CONSTANTS 
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      LOGICAL CHECKPCONSERVATION
      PARAMETER (CHECKPCONSERVATION=.TRUE.)
      REAL*8 NORMALIZATION
      PARAMETER (NORMALIZATION = 1.D0/(16.D0*3.14159265358979323846D0*
     $ *2))
C     
C     ARGUMENTS 
C     
      INTEGER NLOOPLINE, RANK
      REAL*8 PL(0:3,NLOOPLINE)
      REAL*8 PCT(0:3,0:NLOOPLINE-1)
      COMPLEX*16 M2L(NLOOPLINE)
      COMPLEX*16 M2LCT(0:NLOOPLINE-1)
      COMPLEX*16 RES(3)
C     
C     LOCAL VARIABLES 
C     
      COMPLEX*16 R1, ACC
      INTEGER I, J, K
      INTEGER CTMODE
      LOGICAL STABLE
      LOGICAL INIT
      DATA INIT /.TRUE./
      SAVE INIT
C     
C     EXTERNAL FUNCTIONS
C     
      EXTERNAL LOOPNUM
      EXTERNAL MPLOOPNUM
C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'
      REAL*8 LSCALE
      COMMON/CT/LSCALE

C     ----------
C     BEGIN CODE
C     ----------

C     INITIALIZE CUTTOOLS IF NEEDED
      IF (INIT) THEN
        INIT=.FALSE.
        CALL INITCT()
      ENDIF

C     DECIDE WHAT CT MODE TO USE FOR TREATING THIS PARTICULAR LOOP
C     IN THE ACTUAL SETUP, WE ALWAYS USE ZERO.
C     YOU CAN FIND THE DETAILS ABOUT THE DIFFERENT MODE AT THE
C      BEGINNING OF THE FILE CTS_CUTS.F90 IN THE CUTTOOLS DISTRIBUTION

      CTMODE=0

C     CONVERT THE MASSES TO BE COMPLEX
      DO I=1,NLOOPLINE
        M2LCT(I-1)=M2L(I)
      ENDDO

C     CONVERT THE MOMENTA FLOWING IN THE LOOP LINES TO CT CONVENTIONS
      DO I=0,3
        DO J=0,(NLOOPLINE-1)
          PCT(I,J)=0.D0
        ENDDO
      ENDDO
      DO I=0,3
        DO J=1,NLOOPLINE
          PCT(I,0)=PCT(I,0)+PL(I,J)
        ENDDO
      ENDDO
      IF (CHECKPCONSERVATION) THEN
        IF (PCT(0,0).GT.1.D-6) THEN
          WRITE(*,*) 'energy is not conserved ',PCT(0,0)
          STOP 'energy is not conserved'
        ELSEIF (PCT(1,0).GT.1.D-6) THEN
          WRITE(*,*) 'px is not conserved ',PCT(1,0)
          STOP 'px is not conserved'
        ELSEIF (PCT(2,0).GT.1.D-6) THEN
          WRITE(*,*) 'py is not conserved ',PCT(2,0)
          STOP 'py is not conserved'
        ELSEIF (PCT(3,0).GT.1.D-6) THEN
          WRITE(*,*) 'pz is not conserved ',PCT(3,0)
          STOP 'pz is not conserved'
        ENDIF
      ENDIF
      DO I=0,3
        DO J=1,(NLOOPLINE-1)
          DO K=1,J
            PCT(I,J)=PCT(I,J)+PL(I,K)
          ENDDO
        ENDDO
      ENDDO

      CALL CTSXCUT(CTMODE,LSCALE,MU_R,NLOOPLINE,LOOPNUM,MPLOOPNUM,RANK
     $ ,PCT,M2LCT,RES,ACC,R1,STABLE)
      RES(1)=NORMALIZATION*RES(1)
      RES(2)=NORMALIZATION*RES(2)
      RES(3)=NORMALIZATION*RES(3)
      END

      SUBROUTINE INITCT()
C     
C     INITIALISATION OF CUTTOOLS
C     
C     LOCAL VARIABLES 
C     
      REAL*8 THRS

C     ----------
C     BEGIN CODE
C     ----------

C     DEFAULT PARAMETERS FOR CUTTOOLS
C     -------------------------------  
C     THRS1 IS THE PRECISION LIMIT BELOW WHICH THE MP ROUTINES
C      ACTIVATES
      THRS=1.D-2
C     LOOPLIB SET WHAT LIBRARY CT USES
C     1 -> LOOPTOOLS
C     2 -> AVH
C     3 -> QCDLOOP
      LOOPLIB=2
C     -------------------------------	  

      CALL CTSINIT(THRS,LOOPLIB)

      END

      SUBROUTINE LOOP_4_4( LID, W1, MP1, W2, MP2, W3, MP3, W4, MP4, M1
     $ , M2, M3, M4, C1, C2, C3, C4,  RANK, LSYMFACT, RES,CONTRIBUTE)
C     
C     CONSTANTS 
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    MAXLCOUPLINGS
      PARAMETER (MAXLCOUPLINGS=6)
      INTEGER    NLOOPLINE
      PARAMETER (NLOOPLINE=4)
C     
C     ARGUMENTS
C     
      COMPLEX*16 W1(20), W2(20), W3(20), W4(20)
      INTEGER MP1, MP2, MP3, MP4
      COMPLEX*16 M1, M2, M3, M4
      COMPLEX*16 C1, C2, C3, C4
      COMPLEX*16 RES(3)
      INTEGER LID, RANK, LSYMFACT
      LOGICAL CONTRIBUTE
C     
C     LOCAL VARIABLES 
C     
      REAL*8 PL(0:3,NLOOPLINE)
      COMPLEX*16 M2L(NLOOPLINE)
      INTEGER MOMPOS(4)
      INTEGER I, J
C     
C     GLOBAL VARIABLES
C     
      COMPLEX*16 WE(20,NEXTERNAL)
      COMPLEX*16 LC(MAXLCOUPLINGS)
      COMPLEX*16 ML(NEXTERNAL+2)
      INTEGER ID, SYMFACT
      COMMON/LOOP/WE,LC,ML,ID,SYMFACT
C     ----------
C     BEGIN CODE
C     ----------
      IF (.NOT.CONTRIBUTE) THEN
        RES(1)=(0.D0,0.D0)
        RES(2)=(0.D0,0.D0)
        RES(3)=(0.D0,0.D0)
      ELSE
        DO I=1,20
          WE(I,1)=W1(I)
          WE(I,2)=W2(I)
          WE(I,3)=W3(I)
          WE(I,4)=W4(I)
        ENDDO
        MOMPOS(1)=MP1
        MOMPOS(2)=MP2
        MOMPOS(3)=MP3
        MOMPOS(4)=MP4
        M2L(1)=M4**2
        M2L(2)=M1**2
        M2L(3)=M2**2
        M2L(4)=M3**2
        ML(1)=M4
        ML(2)=M4
        ML(3)=M1
        ML(4)=M2
        ML(5)=M3
        ML(6)=M4
        LC(1)=C1
        LC(2)=C2
        LC(3)=C3
        LC(4)=C4
        ID=LID
        SYMFACT=LSYMFACT
        DO I=0,3
          DO J=1,NLOOPLINE
            PL(I,J)=SIGN(1,MOMPOS(J))*DBLE(WE(ABS(MOMPOS(J))+I,J))
          ENDDO
        ENDDO
        CALL CTLOOP(NLOOPLINE,PL,M2L,RANK,RES)
      ENDIF

      END

      SUBROUTINE LOOP_4_5( LID, W1, MP1, W2, MP2, W3, MP3, W4, MP4, M1
     $ , M2, M3, M4, C1, C2, C3, C4, C5,  RANK, LSYMFACT, RES
     $ ,CONTRIBUTE)
C     
C     CONSTANTS 
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    MAXLCOUPLINGS
      PARAMETER (MAXLCOUPLINGS=6)
      INTEGER    NLOOPLINE
      PARAMETER (NLOOPLINE=4)
C     
C     ARGUMENTS
C     
      COMPLEX*16 W1(20), W2(20), W3(20), W4(20)
      INTEGER MP1, MP2, MP3, MP4
      COMPLEX*16 M1, M2, M3, M4
      COMPLEX*16 C1, C2, C3, C4, C5
      COMPLEX*16 RES(3)
      INTEGER LID, RANK, LSYMFACT
      LOGICAL CONTRIBUTE
C     
C     LOCAL VARIABLES 
C     
      REAL*8 PL(0:3,NLOOPLINE)
      COMPLEX*16 M2L(NLOOPLINE)
      INTEGER MOMPOS(4)
      INTEGER I, J
C     
C     GLOBAL VARIABLES
C     
      COMPLEX*16 WE(20,NEXTERNAL)
      COMPLEX*16 LC(MAXLCOUPLINGS)
      COMPLEX*16 ML(NEXTERNAL+2)
      INTEGER ID, SYMFACT
      COMMON/LOOP/WE,LC,ML,ID,SYMFACT
C     ----------
C     BEGIN CODE
C     ----------
      IF (.NOT.CONTRIBUTE) THEN
        RES(1)=(0.D0,0.D0)
        RES(2)=(0.D0,0.D0)
        RES(3)=(0.D0,0.D0)
      ELSE
        DO I=1,20
          WE(I,1)=W1(I)
          WE(I,2)=W2(I)
          WE(I,3)=W3(I)
          WE(I,4)=W4(I)
        ENDDO
        MOMPOS(1)=MP1
        MOMPOS(2)=MP2
        MOMPOS(3)=MP3
        MOMPOS(4)=MP4
        M2L(1)=M4**2
        M2L(2)=M1**2
        M2L(3)=M2**2
        M2L(4)=M3**2
        ML(1)=M4
        ML(2)=M4
        ML(3)=M1
        ML(4)=M2
        ML(5)=M3
        ML(6)=M4
        LC(1)=C1
        LC(2)=C2
        LC(3)=C3
        LC(4)=C4
        LC(5)=C5
        ID=LID
        SYMFACT=LSYMFACT
        DO I=0,3
          DO J=1,NLOOPLINE
            PL(I,J)=SIGN(1,MOMPOS(J))*DBLE(WE(ABS(MOMPOS(J))+I,J))
          ENDDO
        ENDDO
        CALL CTLOOP(NLOOPLINE,PL,M2L,RANK,RES)
      ENDIF

      END

      SUBROUTINE LOOP_4_6( LID, W1, MP1, W2, MP2, W3, MP3, W4, MP4, M1
     $ , M2, M3, M4, C1, C2, C3, C4, C5, C6,  RANK, LSYMFACT, RES
     $ ,CONTRIBUTE)
C     
C     CONSTANTS 
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    MAXLCOUPLINGS
      PARAMETER (MAXLCOUPLINGS=6)
      INTEGER    NLOOPLINE
      PARAMETER (NLOOPLINE=4)
C     
C     ARGUMENTS
C     
      COMPLEX*16 W1(20), W2(20), W3(20), W4(20)
      INTEGER MP1, MP2, MP3, MP4
      COMPLEX*16 M1, M2, M3, M4
      COMPLEX*16 C1, C2, C3, C4, C5, C6
      COMPLEX*16 RES(3)
      INTEGER LID, RANK, LSYMFACT
      LOGICAL CONTRIBUTE
C     
C     LOCAL VARIABLES 
C     
      REAL*8 PL(0:3,NLOOPLINE)
      COMPLEX*16 M2L(NLOOPLINE)
      INTEGER MOMPOS(4)
      INTEGER I, J
C     
C     GLOBAL VARIABLES
C     
      COMPLEX*16 WE(20,NEXTERNAL)
      COMPLEX*16 LC(MAXLCOUPLINGS)
      COMPLEX*16 ML(NEXTERNAL+2)
      INTEGER ID, SYMFACT
      COMMON/LOOP/WE,LC,ML,ID,SYMFACT
C     ----------
C     BEGIN CODE
C     ----------
      IF (.NOT.CONTRIBUTE) THEN
        RES(1)=(0.D0,0.D0)
        RES(2)=(0.D0,0.D0)
        RES(3)=(0.D0,0.D0)
      ELSE
        DO I=1,20
          WE(I,1)=W1(I)
          WE(I,2)=W2(I)
          WE(I,3)=W3(I)
          WE(I,4)=W4(I)
        ENDDO
        MOMPOS(1)=MP1
        MOMPOS(2)=MP2
        MOMPOS(3)=MP3
        MOMPOS(4)=MP4
        M2L(1)=M4**2
        M2L(2)=M1**2
        M2L(3)=M2**2
        M2L(4)=M3**2
        ML(1)=M4
        ML(2)=M4
        ML(3)=M1
        ML(4)=M2
        ML(5)=M3
        ML(6)=M4
        LC(1)=C1
        LC(2)=C2
        LC(3)=C3
        LC(4)=C4
        LC(5)=C5
        LC(6)=C6
        ID=LID
        SYMFACT=LSYMFACT
        DO I=0,3
          DO J=1,NLOOPLINE
            PL(I,J)=SIGN(1,MOMPOS(J))*DBLE(WE(ABS(MOMPOS(J))+I,J))
          ENDDO
        ENDDO
        CALL CTLOOP(NLOOPLINE,PL,M2L,RANK,RES)
      ENDIF

      END

      SUBROUTINE LOOP_3_3( LID, W1, MP1, W2, MP2, W3, MP3, M1, M2, M3
     $ , C1, C2, C3,  RANK, LSYMFACT, RES,CONTRIBUTE)
C     
C     CONSTANTS 
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    MAXLCOUPLINGS
      PARAMETER (MAXLCOUPLINGS=6)
      INTEGER    NLOOPLINE
      PARAMETER (NLOOPLINE=3)
C     
C     ARGUMENTS
C     
      COMPLEX*16 W1(20), W2(20), W3(20)
      INTEGER MP1, MP2, MP3
      COMPLEX*16 M1, M2, M3
      COMPLEX*16 C1, C2, C3
      COMPLEX*16 RES(3)
      INTEGER LID, RANK, LSYMFACT
      LOGICAL CONTRIBUTE
C     
C     LOCAL VARIABLES 
C     
      REAL*8 PL(0:3,NLOOPLINE)
      COMPLEX*16 M2L(NLOOPLINE)
      INTEGER MOMPOS(3)
      INTEGER I, J
C     
C     GLOBAL VARIABLES
C     
      COMPLEX*16 WE(20,NEXTERNAL)
      COMPLEX*16 LC(MAXLCOUPLINGS)
      COMPLEX*16 ML(NEXTERNAL+2)
      INTEGER ID, SYMFACT
      COMMON/LOOP/WE,LC,ML,ID,SYMFACT
C     ----------
C     BEGIN CODE
C     ----------
      IF (.NOT.CONTRIBUTE) THEN
        RES(1)=(0.D0,0.D0)
        RES(2)=(0.D0,0.D0)
        RES(3)=(0.D0,0.D0)
      ELSE
        DO I=1,20
          WE(I,1)=W1(I)
          WE(I,2)=W2(I)
          WE(I,3)=W3(I)
        ENDDO
        MOMPOS(1)=MP1
        MOMPOS(2)=MP2
        MOMPOS(3)=MP3
        M2L(1)=M3**2
        M2L(2)=M1**2
        M2L(3)=M2**2
        ML(1)=M3
        ML(2)=M3
        ML(3)=M1
        ML(4)=M2
        ML(5)=M3
        LC(1)=C1
        LC(2)=C2
        LC(3)=C3
        ID=LID
        SYMFACT=LSYMFACT
        DO I=0,3
          DO J=1,NLOOPLINE
            PL(I,J)=SIGN(1,MOMPOS(J))*DBLE(WE(ABS(MOMPOS(J))+I,J))
          ENDDO
        ENDDO
        CALL CTLOOP(NLOOPLINE,PL,M2L,RANK,RES)
      ENDIF

      END

