      SUBROUTINE SLOOPMATRIX(P,ANS)
C     
C     Generated by MadGraph 5 v. 1.4.3, 2012-03-08
C     By the MadGraph Development Team
C     Please visit us at https://launchpad.net/madgraph5
C     
C     MadGraph StandAlone Version
C     
C     Returns amplitude squared summed/avg over colors
C     and helicities
C     for the point in phase space P(0:3,NEXTERNAL)
C     
C     Process: g g > e+ e- mu+ mu- [ QCD ] WEIGHTED=20 / e- mu-
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    NCOMB
      PARAMETER (NCOMB=64)
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL),ANS(3)
C     
C     GLOBAL VARIABLES
C     
      REAL*8 LSCALE
      COMMON/CT/LSCALE
      INTEGER NTRY
      COMMON/INIT/NTRY
C     
C     LOCAL VARIABLES 
C     
      INTEGER NHEL(NEXTERNAL,NCOMB)
      REAL*8 T(3)
      INTEGER IHEL,IDEN, I
      INTEGER JC(NEXTERNAL)
      LOGICAL GOODHEL(NCOMB)
      DATA NTRY/0/
      DATA GOODHEL/NCOMB*.FALSE./

      DATA (NHEL(I,   1),I=1,6) /-1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,   2),I=1,6) /-1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,   3),I=1,6) /-1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,   4),I=1,6) /-1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,   5),I=1,6) /-1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,   6),I=1,6) /-1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,   7),I=1,6) /-1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,   8),I=1,6) /-1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,   9),I=1,6) /-1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  10),I=1,6) /-1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  11),I=1,6) /-1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  12),I=1,6) /-1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  13),I=1,6) /-1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  14),I=1,6) /-1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  15),I=1,6) /-1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  16),I=1,6) /-1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  17),I=1,6) /-1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  18),I=1,6) /-1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  19),I=1,6) /-1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  20),I=1,6) /-1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  21),I=1,6) /-1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  22),I=1,6) /-1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  23),I=1,6) /-1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  24),I=1,6) /-1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  25),I=1,6) /-1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  26),I=1,6) /-1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  27),I=1,6) /-1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  28),I=1,6) /-1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  29),I=1,6) /-1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  30),I=1,6) /-1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  31),I=1,6) /-1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  32),I=1,6) /-1, 1, 1, 1, 1, 1/
      DATA (NHEL(I,  33),I=1,6) / 1,-1,-1,-1,-1,-1/
      DATA (NHEL(I,  34),I=1,6) / 1,-1,-1,-1,-1, 1/
      DATA (NHEL(I,  35),I=1,6) / 1,-1,-1,-1, 1,-1/
      DATA (NHEL(I,  36),I=1,6) / 1,-1,-1,-1, 1, 1/
      DATA (NHEL(I,  37),I=1,6) / 1,-1,-1, 1,-1,-1/
      DATA (NHEL(I,  38),I=1,6) / 1,-1,-1, 1,-1, 1/
      DATA (NHEL(I,  39),I=1,6) / 1,-1,-1, 1, 1,-1/
      DATA (NHEL(I,  40),I=1,6) / 1,-1,-1, 1, 1, 1/
      DATA (NHEL(I,  41),I=1,6) / 1,-1, 1,-1,-1,-1/
      DATA (NHEL(I,  42),I=1,6) / 1,-1, 1,-1,-1, 1/
      DATA (NHEL(I,  43),I=1,6) / 1,-1, 1,-1, 1,-1/
      DATA (NHEL(I,  44),I=1,6) / 1,-1, 1,-1, 1, 1/
      DATA (NHEL(I,  45),I=1,6) / 1,-1, 1, 1,-1,-1/
      DATA (NHEL(I,  46),I=1,6) / 1,-1, 1, 1,-1, 1/
      DATA (NHEL(I,  47),I=1,6) / 1,-1, 1, 1, 1,-1/
      DATA (NHEL(I,  48),I=1,6) / 1,-1, 1, 1, 1, 1/
      DATA (NHEL(I,  49),I=1,6) / 1, 1,-1,-1,-1,-1/
      DATA (NHEL(I,  50),I=1,6) / 1, 1,-1,-1,-1, 1/
      DATA (NHEL(I,  51),I=1,6) / 1, 1,-1,-1, 1,-1/
      DATA (NHEL(I,  52),I=1,6) / 1, 1,-1,-1, 1, 1/
      DATA (NHEL(I,  53),I=1,6) / 1, 1,-1, 1,-1,-1/
      DATA (NHEL(I,  54),I=1,6) / 1, 1,-1, 1,-1, 1/
      DATA (NHEL(I,  55),I=1,6) / 1, 1,-1, 1, 1,-1/
      DATA (NHEL(I,  56),I=1,6) / 1, 1,-1, 1, 1, 1/
      DATA (NHEL(I,  57),I=1,6) / 1, 1, 1,-1,-1,-1/
      DATA (NHEL(I,  58),I=1,6) / 1, 1, 1,-1,-1, 1/
      DATA (NHEL(I,  59),I=1,6) / 1, 1, 1,-1, 1,-1/
      DATA (NHEL(I,  60),I=1,6) / 1, 1, 1,-1, 1, 1/
      DATA (NHEL(I,  61),I=1,6) / 1, 1, 1, 1,-1,-1/
      DATA (NHEL(I,  62),I=1,6) / 1, 1, 1, 1,-1, 1/
      DATA (NHEL(I,  63),I=1,6) / 1, 1, 1, 1, 1,-1/
      DATA (NHEL(I,  64),I=1,6) / 1, 1, 1, 1, 1, 1/
      DATA IDEN/256/

      REAL*8 BKGD_AMP(3),SIGNAL_AMP(3)
      COMMON / C_AMP / BKGD_AMP, SIGNAL_AMP
      REAL*8 BKGD,SIGNAL

C     ----------
C     BEGIN CODE
C     ----------

      LSCALE=DSQRT((P(0,1)+P(0,2))**2-(P(1,1)+P(1,2))**2-(P(2,1)
     $ +P(2,2))**2-(P(3,1)+P(3,2))**2)

      NTRY=NTRY+1
      DO IHEL=1,NEXTERNAL
        JC(IHEL) = +1
      ENDDO
      ANS(1) = 0.D0
      ANS(2) = 0.D0
      ANS(3) = 0.D0
      BKGD = 0.D0
      SIGNAL = 0.D0
      DO IHEL=1,NCOMB
        IF (GOODHEL(IHEL) .OR. NTRY .LT. 2) THEN
          CALL LOOPMATRIX(P ,NHEL(1,IHEL),IHEL,JC(1),T(1))
          DO I=1,3
            ANS(I)=ANS(I)+T(I)
          ENDDO
            BKGD  = BKGD   + BKGD_AMP(1)
            SIGNAL= SIGNAL + SIGNAL_AMP(1)
          IF (T(1) .NE. 0D0 .AND. .NOT.    GOODHEL(IHEL)) THEN
            GOODHEL(IHEL)=.TRUE.
          ENDIF
        ENDIF
      ENDDO
      DO I=1,3
        ANS(I)=ANS(I)/DBLE(IDEN)
      ENDDO
        ANS(2)=BKGD/DBLE(IDEN)  
        ANS(3)=SIGNAL/DBLE(IDEN)

      END


      SUBROUTINE LOOPMATRIX(P,NHEL,H,IC,RES)
C     
C     Generated by MadGraph 5 v. 1.4.3, 2012-03-08
C     By the MadGraph Development Team
C     Please visit us at https://launchpad.net/madgraph5
C     
C     Returns amplitude squared summed/avg over colors
C     for the point with external lines W(0:6,NEXTERNAL)
C     
C     Process: g g > e+ e- mu+ mu- [ QCD ] WEIGHTED=20 / e- mu-
C     
      IMPLICIT NONE
C     
C     CONSTANTS
C     
      INTEGER    NLOOPAMPS, NBORNAMPS
      PARAMETER (NLOOPAMPS=174, NBORNAMPS=0)
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    NWAVEFUNCS
      PARAMETER (NWAVEFUNCS=11)
      INTEGER    NCOLORLOOP, NCOLORBORN
      PARAMETER (NCOLORLOOP=1, NCOLORBORN=1)
      INTEGER    NCOMB
      PARAMETER (NCOMB=64)
      INTEGER    NCOMBAMP
      PARAMETER (NCOMBAMP=NCOMB*NLOOPAMPS)
      REAL*8     ZERO
      PARAMETER (ZERO=0D0)
      COMPLEX*16 IMAG1
      PARAMETER (IMAG1=(0D0,1D0))
C     
C     ARGUMENTS 
C     
      REAL*8 P(0:3,NEXTERNAL)
      INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)
      INTEGER H
      REAL*8 RES(3)
C     
C     LOCAL VARIABLES 
C     
      INTEGER I,J,K
      COMPLEX*16 ZTEMP
      INTEGER DENOM(NCOLORLOOP), CF(NCOLORBORN,NCOLORLOOP)
      COMPLEX*16 AMPL(3,NLOOPAMPS), AMP(NBORNAMPS)
      COMPLEX*16 JAMPL(3,NCOLORLOOP), JAMPB(NCOLORBORN)
      COMPLEX*16 W(20,NWAVEFUNCS)
      LOGICAL GOODAMP(NLOOPAMPS,NCOMB)
      DATA ((GOODAMP(I,J),I=1,NLOOPAMPS),J=1,NCOMB) / NCOMBAMP*.TRUE. /

      INTEGER PROC
      COMPLEX*16 BOX(3,NCOLORLOOP),SIGNAL(3,NCOLORLOOP)
      REAL*8 BKGD_AMP(3),SIGNAL_AMP(3)
      COMMON / C_AMP / BKGD_AMP, SIGNAL_AMP

C     
C     GLOBAL VARIABLES
C     
      INCLUDE 'coupl.inc'
      INTEGER NTRY
      COMMON/INIT/NTRY
C     
C     COLOR DATA
C     
      DATA DENOM(1)/1/
      DATA (CF(I,  1),I=  1,  1) /    2/
C     1 Tr(1,2)
C     ----------
C     BEGIN CODE
C     ----------
      DO K=1, 3
        DO I=1, NLOOPAMPS
          AMPL(K,I)=(0.D0,0.D0)
        ENDDO
      ENDDO

      CALL VXXXXX(P(0,1),ZERO,NHEL(1),-1*IC(1),W(1,1))
      CALL VXXXXX(P(0,2),ZERO,NHEL(2),-1*IC(2),W(1,2))
      CALL IXXXXX(P(0,3),ZERO,NHEL(3),-1*IC(3),W(1,3))
      CALL OXXXXX(P(0,4),ZERO,NHEL(4),+1*IC(4),W(1,4))
      CALL IXXXXX(P(0,5),ZERO,NHEL(5),-1*IC(5),W(1,5))
      CALL OXXXXX(P(0,6),ZERO,NHEL(6),+1*IC(6),W(1,6))
      CALL FFV1_3(W(1,3),W(1,4),GC_3,ZERO,ZERO,W(1,7))
      CALL FFV1_3(W(1,5),W(1,6),GC_3,ZERO,ZERO,W(1,8))
C     Counter-term amplitude(s) for loop diagram number 1
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,7),W(1,8),R2_GGAADOWN,AMPL(1,1))
      CALL FFV2_4_3(W(1,5),W(1,6),GC_21,GC_24,MZ,WZ,W(1,9))
C     Counter-term amplitude(s) for loop diagram number 3
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,9),W(1,7),R2_GGZADOWN,AMPL(1,2))
      CALL FFV2_4_3(W(1,3),W(1,4),GC_21,GC_24,MZ,WZ,W(1,10))
C     Counter-term amplitude(s) for loop diagram number 5
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,8),R2_GGZADOWN,AMPL(1
     $ ,3))
C     Counter-term amplitude(s) for loop diagram number 7
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,9),R2_GGZZDOWN,AMPL(1
     $ ,4))
C     Counter-term amplitude(s) for loop diagram number 25
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,7),W(1,8),R2_GGAAUP,AMPL(1,5))
C     Counter-term amplitude(s) for loop diagram number 27
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,9),W(1,7),R2_GGZAUP,AMPL(1,6))
C     Counter-term amplitude(s) for loop diagram number 29
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,8),R2_GGZAUP,AMPL(1,7))
C     Counter-term amplitude(s) for loop diagram number 31
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,9),R2_GGZZUP,AMPL(1,8))
C     Counter-term amplitude(s) for loop diagram number 49
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,7),W(1,8),R2_GGAADOWN,AMPL(1,9))
C     Counter-term amplitude(s) for loop diagram number 51
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,9),W(1,7),R2_GGZADOWN,AMPL(1
     $ ,10))
C     Counter-term amplitude(s) for loop diagram number 53
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,8),R2_GGZADOWN,AMPL(1
     $ ,11))
C     Counter-term amplitude(s) for loop diagram number 55
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,9),R2_GGZZDOWN,AMPL(1
     $ ,12))
C     Counter-term amplitude(s) for loop diagram number 73
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,7),W(1,8),R2_GGAAUP,AMPL(1,13))
C     Counter-term amplitude(s) for loop diagram number 75
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,9),W(1,7),R2_GGZAUP,AMPL(1,14))
C     Counter-term amplitude(s) for loop diagram number 77
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,8),R2_GGZAUP,AMPL(1,15))
C     Counter-term amplitude(s) for loop diagram number 79
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,9),R2_GGZZUP,AMPL(1,16))
C     Counter-term amplitude(s) for loop diagram number 97
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,7),W(1,8),R2_GGAADOWN,AMPL(1
     $ ,17))
C     Counter-term amplitude(s) for loop diagram number 99
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,9),W(1,7),R2_GGZADOWN,AMPL(1
     $ ,18))
C     Counter-term amplitude(s) for loop diagram number 101
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,8),R2_GGZADOWN,AMPL(1
     $ ,19))
      CALL VVS1_3(W(1,9),W(1,10),GC_32,MH,WH,W(1,11))
C     Counter-term amplitude(s) for loop diagram number 103
      CALL VVS1_0(W(1,1),W(1,2),W(1,11),R2_GGHB,AMPL(1,20))
C     Counter-term amplitude(s) for loop diagram number 104
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,9),R2_GGZZDOWN,AMPL(1
     $ ,21))
C     Counter-term amplitude(s) for loop diagram number 123
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,7),W(1,8),R2_GGAAUP,AMPL(1,22))
C     Counter-term amplitude(s) for loop diagram number 125
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,9),W(1,7),R2_GGZAUP,AMPL(1,23))
C     Counter-term amplitude(s) for loop diagram number 127
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,8),R2_GGZAUP,AMPL(1,24))
C     Counter-term amplitude(s) for loop diagram number 129
      CALL VVS1_0(W(1,1),W(1,2),W(1,11),R2_GGHT,AMPL(1,25))
C     Counter-term amplitude(s) for loop diagram number 130
      CALL R2_GGVV_0(W(1,1),W(1,2),W(1,10),W(1,9),R2_GGZZUP,AMPL(1,26))
C     Loop amplitude for loop diagram with ID 1
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_1,GC_5,4,1,AMPL(1,27),GOODAMP(27,H))
C     Loop amplitude for loop diagram with ID 2
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_1,GC_5,4,1,AMPL(1,28),GOODAMP(28,H))
C     Loop amplitude for loop diagram with ID 3
      CALL LOOP_4_5(2,W(1,1),-5,W(1,7),-5,W(1,9),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_21,GC_23,GC_5,4,1,AMPL(1,29),GOODAMP(29,H))
C     Loop amplitude for loop diagram with ID 4
      CALL LOOP_4_5(3,W(1,1),-5,W(1,9),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_1,GC_5,4,1,AMPL(1,30),GOODAMP(30,H))
C     Loop amplitude for loop diagram with ID 5
      CALL LOOP_4_5(3,W(1,1),-5,W(1,10),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_1,GC_5,4,1,AMPL(1,31),GOODAMP(31,H))
C     Loop amplitude for loop diagram with ID 6
      CALL LOOP_4_5(2,W(1,1),-5,W(1,8),-5,W(1,10),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_21,GC_23,GC_5,4,1,AMPL(1,32),GOODAMP(32,H))
C     Loop amplitude for loop diagram with ID 7
      CALL LOOP_4_6(4,W(1,1),-5,W(1,10),-5,W(1,9),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_21,GC_23,GC_5,4,1,AMPL(1,33),GOODAMP(33,H))
C     Loop amplitude for loop diagram with ID 8
      CALL LOOP_4_6(4,W(1,1),-5,W(1,9),-5,W(1,10),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_21,GC_23,GC_5,4,1,AMPL(1,34),GOODAMP(34,H))
C     Loop amplitude for loop diagram with ID 9
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_1,GC_1,4,1,AMPL(1,35),GOODAMP(35,H))
C     Loop amplitude for loop diagram with ID 10
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_1,GC_1,4,1,AMPL(1,36),GOODAMP(36,H))
C     Loop amplitude for loop diagram with ID 11
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_5,GC_1,4,1,AMPL(1,37),GOODAMP(37,H))
C     Loop amplitude for loop diagram with ID 12
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_5,GC_1,4,1,AMPL(1,38),GOODAMP(38,H))
C     Loop amplitude for loop diagram with ID 13
      CALL LOOP_4_5(2,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_21,GC_23,GC_1,4,1,AMPL(1,39),GOODAMP(39,H))
C     Loop amplitude for loop diagram with ID 14
      CALL LOOP_4_5(5,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_1,GC_21,GC_23,4,1,AMPL(1,40),GOODAMP(40,H))
C     Loop amplitude for loop diagram with ID 15
      CALL LOOP_4_5(5,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_5,GC_21,GC_23,4,1,AMPL(1,41),GOODAMP(41,H))
C     Loop amplitude for loop diagram with ID 16
      CALL LOOP_4_5(3,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_5,GC_1,4,1,AMPL(1,42),GOODAMP(42,H))
C     Loop amplitude for loop diagram with ID 17
      CALL LOOP_4_5(5,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,10),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_1,GC_21,GC_23,4,1,AMPL(1,43),GOODAMP(43,H))
C     Loop amplitude for loop diagram with ID 18
      CALL LOOP_4_5(2,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_21,GC_23,GC_1,4,1,AMPL(1,44),GOODAMP(44,H))
C     Loop amplitude for loop diagram with ID 19
      CALL LOOP_4_5(3,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_5,GC_1,4,1,AMPL(1,45),GOODAMP(45,H))
C     Loop amplitude for loop diagram with ID 20
      CALL LOOP_4_5(5,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,10),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_5,GC_21,GC_23,4,1,AMPL(1,46),GOODAMP(46,H))
C     Loop amplitude for loop diagram with ID 21
      CALL LOOP_4_6(6,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,10),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_21,GC_23,GC_21,GC_23,4,1,AMPL(1,47),GOODAMP(47,H))
C     Loop amplitude for loop diagram with ID 22
      CALL LOOP_4_6(6,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_21,GC_23,GC_21,GC_23,4,1,AMPL(1,48),GOODAMP(48,H))
C     Loop amplitude for loop diagram with ID 23
      CALL LOOP_4_6(7,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_5,GC_21,GC_23,4,1,AMPL(1,49),GOODAMP(49,H))
C     Loop amplitude for loop diagram with ID 24
      CALL LOOP_4_6(7,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,10),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_5,GC_21,GC_23,4,1,AMPL(1,50),GOODAMP(50,H))
C     Loop amplitude for loop diagram with ID 25
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_2,GC_5,4,1,AMPL(1,51),GOODAMP(51,H))
C     Loop amplitude for loop diagram with ID 26
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_2,GC_5,4,1,AMPL(1,52),GOODAMP(52,H))
C     Loop amplitude for loop diagram with ID 27
      CALL LOOP_4_5(8,W(1,1),-5,W(1,7),-5,W(1,9),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_22,GC_23,GC_5,4,1,AMPL(1,53),GOODAMP(53,H))
C     Loop amplitude for loop diagram with ID 28
      CALL LOOP_4_5(9,W(1,1),-5,W(1,9),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_22
     $ ,GC_23,GC_2,GC_5,4,1,AMPL(1,54),GOODAMP(54,H))
C     Loop amplitude for loop diagram with ID 29
      CALL LOOP_4_5(9,W(1,1),-5,W(1,10),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_22
     $ ,GC_23,GC_2,GC_5,4,1,AMPL(1,55),GOODAMP(55,H))
C     Loop amplitude for loop diagram with ID 30
      CALL LOOP_4_5(8,W(1,1),-5,W(1,8),-5,W(1,10),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_22,GC_23,GC_5,4,1,AMPL(1,56),GOODAMP(56,H))
C     Loop amplitude for loop diagram with ID 31
      CALL LOOP_4_6(10,W(1,1),-5,W(1,10),-5,W(1,9),-5,W(1,2),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_22,GC_23,GC_22,GC_23,GC_5,4,1,AMPL(1,57),GOODAMP(57,H))
C     Loop amplitude for loop diagram with ID 32
      CALL LOOP_4_6(10,W(1,1),-5,W(1,9),-5,W(1,10),-5,W(1,2),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_22,GC_23,GC_22,GC_23,GC_5,4,1,AMPL(1,58),GOODAMP(58,H))
C     Loop amplitude for loop diagram with ID 33
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_2,GC_2,4,1,AMPL(1,59),GOODAMP(59,H))
C     Loop amplitude for loop diagram with ID 34
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_2,GC_2,4,1,AMPL(1,60),GOODAMP(60,H))
C     Loop amplitude for loop diagram with ID 35
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_5,GC_2,4,1,AMPL(1,61),GOODAMP(61,H))
C     Loop amplitude for loop diagram with ID 36
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_5,GC_2,4,1,AMPL(1,62),GOODAMP(62,H))
C     Loop amplitude for loop diagram with ID 37
      CALL LOOP_4_5(8,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_22,GC_23,GC_2,4,1,AMPL(1,63),GOODAMP(63,H))
C     Loop amplitude for loop diagram with ID 38
      CALL LOOP_4_5(11,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_2,GC_22,GC_23,4,1,AMPL(1,64),GOODAMP(64,H))
C     Loop amplitude for loop diagram with ID 39
      CALL LOOP_4_5(11,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_5,GC_22,GC_23,4,1,AMPL(1,65),GOODAMP(65,H))
C     Loop amplitude for loop diagram with ID 40
      CALL LOOP_4_5(9,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_22
     $ ,GC_23,GC_5,GC_2,4,1,AMPL(1,66),GOODAMP(66,H))
C     Loop amplitude for loop diagram with ID 41
      CALL LOOP_4_5(11,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,10),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_5,GC_2,GC_22,GC_23,4,1,AMPL(1,67),GOODAMP(67,H))
C     Loop amplitude for loop diagram with ID 42
      CALL LOOP_4_5(8,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_22,GC_23,GC_2,4,1,AMPL(1,68),GOODAMP(68,H))
C     Loop amplitude for loop diagram with ID 43
      CALL LOOP_4_5(9,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_22
     $ ,GC_23,GC_5,GC_2,4,1,AMPL(1,69),GOODAMP(69,H))
C     Loop amplitude for loop diagram with ID 44
      CALL LOOP_4_5(11,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,10),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_2,GC_5,GC_22,GC_23,4,1,AMPL(1,70),GOODAMP(70,H))
C     Loop amplitude for loop diagram with ID 45
      CALL LOOP_4_6(12,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,10),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_5,GC_22,GC_23,GC_22,GC_23,4,1,AMPL(1,71),GOODAMP(71,H))
C     Loop amplitude for loop diagram with ID 46
      CALL LOOP_4_6(12,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,9),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_5,GC_22,GC_23,GC_22,GC_23,4,1,AMPL(1,72),GOODAMP(72,H))
C     Loop amplitude for loop diagram with ID 47
      CALL LOOP_4_6(13,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,9),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_22,GC_23,GC_5,GC_22,GC_23,4,1,AMPL(1,73),GOODAMP(73,H))
C     Loop amplitude for loop diagram with ID 48
      CALL LOOP_4_6(13,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,10),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_22,GC_23,GC_5,GC_22,GC_23,4,1,AMPL(1,74),GOODAMP(74,H))
C     Loop amplitude for loop diagram with ID 49
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_1,GC_5,4,1,AMPL(1,75),GOODAMP(75,H))
C     Loop amplitude for loop diagram with ID 50
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_1,GC_5,4,1,AMPL(1,76),GOODAMP(76,H))
C     Loop amplitude for loop diagram with ID 51
      CALL LOOP_4_5(2,W(1,1),-5,W(1,7),-5,W(1,9),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_21,GC_23,GC_5,4,1,AMPL(1,77),GOODAMP(77,H))
C     Loop amplitude for loop diagram with ID 52
      CALL LOOP_4_5(3,W(1,1),-5,W(1,9),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_1,GC_5,4,1,AMPL(1,78),GOODAMP(78,H))
C     Loop amplitude for loop diagram with ID 53
      CALL LOOP_4_5(3,W(1,1),-5,W(1,10),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_1,GC_5,4,1,AMPL(1,79),GOODAMP(79,H))
C     Loop amplitude for loop diagram with ID 54
      CALL LOOP_4_5(2,W(1,1),-5,W(1,8),-5,W(1,10),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_21,GC_23,GC_5,4,1,AMPL(1,80),GOODAMP(80,H))
C     Loop amplitude for loop diagram with ID 55
      CALL LOOP_4_6(4,W(1,1),-5,W(1,10),-5,W(1,9),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_21,GC_23,GC_5,4,1,AMPL(1,81),GOODAMP(81,H))
C     Loop amplitude for loop diagram with ID 56
      CALL LOOP_4_6(4,W(1,1),-5,W(1,9),-5,W(1,10),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_21,GC_23,GC_5,4,1,AMPL(1,82),GOODAMP(82,H))
C     Loop amplitude for loop diagram with ID 57
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_1,GC_1,4,1,AMPL(1,83),GOODAMP(83,H))
C     Loop amplitude for loop diagram with ID 58
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_1,GC_1,4,1,AMPL(1,84),GOODAMP(84,H))
C     Loop amplitude for loop diagram with ID 59
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_5,GC_1,4,1,AMPL(1,85),GOODAMP(85,H))
C     Loop amplitude for loop diagram with ID 60
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_5,GC_1,4,1,AMPL(1,86),GOODAMP(86,H))
C     Loop amplitude for loop diagram with ID 61
      CALL LOOP_4_5(2,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_21,GC_23,GC_1,4,1,AMPL(1,87),GOODAMP(87,H))
C     Loop amplitude for loop diagram with ID 62
      CALL LOOP_4_5(5,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_1,GC_21,GC_23,4,1,AMPL(1,88),GOODAMP(88,H))
C     Loop amplitude for loop diagram with ID 63
      CALL LOOP_4_5(5,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_5,GC_21,GC_23,4,1,AMPL(1,89),GOODAMP(89,H))
C     Loop amplitude for loop diagram with ID 64
      CALL LOOP_4_5(3,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_5,GC_1,4,1,AMPL(1,90),GOODAMP(90,H))
C     Loop amplitude for loop diagram with ID 65
      CALL LOOP_4_5(5,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,10),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_1,GC_21,GC_23,4,1,AMPL(1,91),GOODAMP(91,H))
C     Loop amplitude for loop diagram with ID 66
      CALL LOOP_4_5(2,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_21,GC_23,GC_1,4,1,AMPL(1,92),GOODAMP(92,H))
C     Loop amplitude for loop diagram with ID 67
      CALL LOOP_4_5(3,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_5,GC_1,4,1,AMPL(1,93),GOODAMP(93,H))
C     Loop amplitude for loop diagram with ID 68
      CALL LOOP_4_5(5,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,10),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_1
     $ ,GC_5,GC_21,GC_23,4,1,AMPL(1,94),GOODAMP(94,H))
C     Loop amplitude for loop diagram with ID 69
      CALL LOOP_4_6(6,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,10),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_21,GC_23,GC_21,GC_23,4,1,AMPL(1,95),GOODAMP(95,H))
C     Loop amplitude for loop diagram with ID 70
      CALL LOOP_4_6(6,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_21,GC_23,GC_21,GC_23,4,1,AMPL(1,96),GOODAMP(96,H))
C     Loop amplitude for loop diagram with ID 71
      CALL LOOP_4_6(7,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_5,GC_21,GC_23,4,1,AMPL(1,97),GOODAMP(97,H))
C     Loop amplitude for loop diagram with ID 72
      CALL LOOP_4_6(7,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,10),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_21
     $ ,GC_23,GC_5,GC_21,GC_23,4,1,AMPL(1,98),GOODAMP(98,H))
C     Loop amplitude for loop diagram with ID 73
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_2,GC_5,4,1,AMPL(1,99),GOODAMP(99,H))
C     Loop amplitude for loop diagram with ID 74
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_2,GC_5,4,1,AMPL(1,100),GOODAMP(100,H))
C     Loop amplitude for loop diagram with ID 75
      CALL LOOP_4_5(8,W(1,1),-5,W(1,7),-5,W(1,9),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_22,GC_23,GC_5,4,1,AMPL(1,101),GOODAMP(101,H))
C     Loop amplitude for loop diagram with ID 76
      CALL LOOP_4_5(9,W(1,1),-5,W(1,9),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_22
     $ ,GC_23,GC_2,GC_5,4,1,AMPL(1,102),GOODAMP(102,H))
C     Loop amplitude for loop diagram with ID 77
      CALL LOOP_4_5(9,W(1,1),-5,W(1,10),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_22
     $ ,GC_23,GC_2,GC_5,4,1,AMPL(1,103),GOODAMP(103,H))
C     Loop amplitude for loop diagram with ID 78
      CALL LOOP_4_5(8,W(1,1),-5,W(1,8),-5,W(1,10),-5,W(1,2),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_22,GC_23,GC_5,4,1,AMPL(1,104),GOODAMP(104,H))
C     Loop amplitude for loop diagram with ID 79
      CALL LOOP_4_6(10,W(1,1),-5,W(1,10),-5,W(1,9),-5,W(1,2),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_22,GC_23,GC_22,GC_23,GC_5,4,1,AMPL(1,105),GOODAMP(105,H))
C     Loop amplitude for loop diagram with ID 80
      CALL LOOP_4_6(10,W(1,1),-5,W(1,9),-5,W(1,10),-5,W(1,2),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_22,GC_23,GC_22,GC_23,GC_5,4,1,AMPL(1,106),GOODAMP(106,H))
C     Loop amplitude for loop diagram with ID 81
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_2,GC_2,4,1,AMPL(1,107),GOODAMP(107,H))
C     Loop amplitude for loop diagram with ID 82
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_2,GC_2,4,1,AMPL(1,108),GOODAMP(108,H))
C     Loop amplitude for loop diagram with ID 83
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_5,GC_2,4,1,AMPL(1,109),GOODAMP(109,H))
C     Loop amplitude for loop diagram with ID 84
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_5,GC_2,4,1,AMPL(1,110),GOODAMP(110,H))
C     Loop amplitude for loop diagram with ID 85
      CALL LOOP_4_5(8,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_22,GC_23,GC_2,4,1,AMPL(1,111),GOODAMP(111,H))
C     Loop amplitude for loop diagram with ID 86
      CALL LOOP_4_5(11,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_2,GC_22,GC_23,4,1,AMPL(1,112),GOODAMP(112,H))
C     Loop amplitude for loop diagram with ID 87
      CALL LOOP_4_5(11,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,9),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_2
     $ ,GC_5,GC_22,GC_23,4,1,AMPL(1,113),GOODAMP(113,H))
C     Loop amplitude for loop diagram with ID 88
      CALL LOOP_4_5(9,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_22
     $ ,GC_23,GC_5,GC_2,4,1,AMPL(1,114),GOODAMP(114,H))
C     Loop amplitude for loop diagram with ID 89
      CALL LOOP_4_5(11,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,10),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_5,GC_2,GC_22,GC_23,4,1,AMPL(1,115),GOODAMP(115,H))
C     Loop amplitude for loop diagram with ID 90
      CALL LOOP_4_5(8,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_5
     $ ,GC_22,GC_23,GC_2,4,1,AMPL(1,116),GOODAMP(116,H))
C     Loop amplitude for loop diagram with ID 91
      CALL LOOP_4_5(9,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5,GC_22
     $ ,GC_23,GC_5,GC_2,4,1,AMPL(1,117),GOODAMP(117,H))
C     Loop amplitude for loop diagram with ID 92
      CALL LOOP_4_5(11,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,10),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_2,GC_5,GC_22,GC_23,4,1,AMPL(1,118),GOODAMP(118,H))
C     Loop amplitude for loop diagram with ID 93
      CALL LOOP_4_6(12,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,10),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_5,GC_22,GC_23,GC_22,GC_23,4,1,AMPL(1,119),GOODAMP(119,H))
C     Loop amplitude for loop diagram with ID 94
      CALL LOOP_4_6(12,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,9),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_5,GC_22,GC_23,GC_22,GC_23,4,1,AMPL(1,120),GOODAMP(120,H))
C     Loop amplitude for loop diagram with ID 95
      CALL LOOP_4_6(13,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,9),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_22,GC_23,GC_5,GC_22,GC_23,4,1,AMPL(1,121),GOODAMP(121,H))
C     Loop amplitude for loop diagram with ID 96
      CALL LOOP_4_6(13,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,10),
     $ -5,DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),DCMPLX(ZERO),GC_5
     $ ,GC_22,GC_23,GC_5,GC_22,GC_23,4,1,AMPL(1,122),GOODAMP(122,H))
C     Loop amplitude for loop diagram with ID 97
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_1,GC_1
     $ ,GC_5,4,1,AMPL(1,123),GOODAMP(123,H))
C     Loop amplitude for loop diagram with ID 98
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_1,GC_1
     $ ,GC_5,4,1,AMPL(1,124),GOODAMP(124,H))
C     Loop amplitude for loop diagram with ID 99
      CALL LOOP_4_5(2,W(1,1),-5,W(1,7),-5,W(1,9),-5,W(1,2),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_1,GC_21
     $ ,GC_23,GC_5,4,1,AMPL(1,125),GOODAMP(125,H))
C     Loop amplitude for loop diagram with ID 100
      CALL LOOP_4_5(3,W(1,1),-5,W(1,9),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_21,GC_23
     $ ,GC_1,GC_5,4,1,AMPL(1,126),GOODAMP(126,H))
C     Loop amplitude for loop diagram with ID 101
      CALL LOOP_4_5(3,W(1,1),-5,W(1,10),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_21,GC_23
     $ ,GC_1,GC_5,4,1,AMPL(1,127),GOODAMP(127,H))
C     Loop amplitude for loop diagram with ID 102
      CALL LOOP_4_5(2,W(1,1),-5,W(1,8),-5,W(1,10),-5,W(1,2),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_1,GC_21
     $ ,GC_23,GC_5,4,1,AMPL(1,128),GOODAMP(128,H))
C     Loop amplitude for loop diagram with ID 103
      CALL LOOP_3_3(14,W(1,1),-5,W(1,11),-2,W(1,2),-5,DCMPLX(MB)
     $ ,DCMPLX(MB),DCMPLX(MB),GC_5,GC_33,GC_5,3,1,AMPL(1,129)
     $ ,GOODAMP(129,H))
C     Loop amplitude for loop diagram with ID 104
      CALL LOOP_4_6(4,W(1,1),-5,W(1,10),-5,W(1,9),-5,W(1,2),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_21,GC_23
     $ ,GC_21,GC_23,GC_5,4,1,AMPL(1,130),GOODAMP(130,H))
C     Loop amplitude for loop diagram with ID 105
      CALL LOOP_4_6(4,W(1,1),-5,W(1,9),-5,W(1,10),-5,W(1,2),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_21,GC_23
     $ ,GC_21,GC_23,GC_5,4,1,AMPL(1,131),GOODAMP(131,H))
C     Loop amplitude for loop diagram with ID 106
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,7),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_5,GC_1
     $ ,GC_1,4,1,AMPL(1,132),GOODAMP(132,H))
C     Loop amplitude for loop diagram with ID 107
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,8),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_5,GC_1
     $ ,GC_1,4,1,AMPL(1,133),GOODAMP(133,H))
C     Loop amplitude for loop diagram with ID 108
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_1,GC_5
     $ ,GC_1,4,1,AMPL(1,134),GOODAMP(134,H))
C     Loop amplitude for loop diagram with ID 109
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_1,GC_5
     $ ,GC_1,4,1,AMPL(1,135),GOODAMP(135,H))
C     Loop amplitude for loop diagram with ID 110
      CALL LOOP_4_5(2,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,7),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_5,GC_21
     $ ,GC_23,GC_1,4,1,AMPL(1,136),GOODAMP(136,H))
C     Loop amplitude for loop diagram with ID 111
      CALL LOOP_4_5(5,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,9),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_5,GC_1
     $ ,GC_21,GC_23,4,1,AMPL(1,137),GOODAMP(137,H))
C     Loop amplitude for loop diagram with ID 112
      CALL LOOP_4_5(5,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,9),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_1,GC_5
     $ ,GC_21,GC_23,4,1,AMPL(1,138),GOODAMP(138,H))
C     Loop amplitude for loop diagram with ID 113
      CALL LOOP_4_5(3,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_21,GC_23
     $ ,GC_5,GC_1,4,1,AMPL(1,139),GOODAMP(139,H))
C     Loop amplitude for loop diagram with ID 114
      CALL LOOP_4_5(5,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,10),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_5,GC_1
     $ ,GC_21,GC_23,4,1,AMPL(1,140),GOODAMP(140,H))
C     Loop amplitude for loop diagram with ID 115
      CALL LOOP_4_5(2,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,8),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_5,GC_21
     $ ,GC_23,GC_1,4,1,AMPL(1,141),GOODAMP(141,H))
C     Loop amplitude for loop diagram with ID 116
      CALL LOOP_4_5(3,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_21,GC_23
     $ ,GC_5,GC_1,4,1,AMPL(1,142),GOODAMP(142,H))
C     Loop amplitude for loop diagram with ID 117
      CALL LOOP_4_5(5,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,10),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_1,GC_5
     $ ,GC_21,GC_23,4,1,AMPL(1,143),GOODAMP(143,H))
C     Loop amplitude for loop diagram with ID 118
      CALL LOOP_3_3(15,W(1,1),-5,W(1,2),-5,W(1,11),-2,DCMPLX(MB)
     $ ,DCMPLX(MB),DCMPLX(MB),GC_5,GC_5,GC_33,3,1,AMPL(1,144)
     $ ,GOODAMP(144,H))
C     Loop amplitude for loop diagram with ID 119
      CALL LOOP_4_6(6,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,10),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_5,GC_21
     $ ,GC_23,GC_21,GC_23,4,1,AMPL(1,145),GOODAMP(145,H))
C     Loop amplitude for loop diagram with ID 120
      CALL LOOP_4_6(6,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,9),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_5,GC_21
     $ ,GC_23,GC_21,GC_23,4,1,AMPL(1,146),GOODAMP(146,H))
C     Loop amplitude for loop diagram with ID 121
      CALL LOOP_4_6(7,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,9),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_21,GC_23
     $ ,GC_5,GC_21,GC_23,4,1,AMPL(1,147),GOODAMP(147,H))
C     Loop amplitude for loop diagram with ID 122
      CALL LOOP_4_6(7,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,10),-5
     $ ,DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),DCMPLX(MB),GC_5,GC_21,GC_23
     $ ,GC_5,GC_21,GC_23,4,1,AMPL(1,148),GOODAMP(148,H))
C     Loop amplitude for loop diagram with ID 123
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_2,GC_2
     $ ,GC_5,4,1,AMPL(1,149),GOODAMP(149,H))
C     Loop amplitude for loop diagram with ID 124
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_2,GC_2
     $ ,GC_5,4,1,AMPL(1,150),GOODAMP(150,H))
C     Loop amplitude for loop diagram with ID 125
      CALL LOOP_4_5(8,W(1,1),-5,W(1,7),-5,W(1,9),-5,W(1,2),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_2,GC_22
     $ ,GC_23,GC_5,4,1,AMPL(1,151),GOODAMP(151,H))
C     Loop amplitude for loop diagram with ID 126
      CALL LOOP_4_5(9,W(1,1),-5,W(1,9),-5,W(1,7),-5,W(1,2),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_22,GC_23
     $ ,GC_2,GC_5,4,1,AMPL(1,152),GOODAMP(152,H))
C     Loop amplitude for loop diagram with ID 127
      CALL LOOP_4_5(9,W(1,1),-5,W(1,10),-5,W(1,8),-5,W(1,2),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_22,GC_23
     $ ,GC_2,GC_5,4,1,AMPL(1,153),GOODAMP(153,H))
C     Loop amplitude for loop diagram with ID 128
      CALL LOOP_4_5(8,W(1,1),-5,W(1,8),-5,W(1,10),-5,W(1,2),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_2,GC_22
     $ ,GC_23,GC_5,4,1,AMPL(1,154),GOODAMP(154,H))
C     Loop amplitude for loop diagram with ID 129
      CALL LOOP_3_3(14,W(1,1),-5,W(1,11),-2,W(1,2),-5,DCMPLX(MT)
     $ ,DCMPLX(MT),DCMPLX(MT),GC_5,GC_37,GC_5,3,1,AMPL(1,155)
     $ ,GOODAMP(155,H))
C     Loop amplitude for loop diagram with ID 130
      CALL LOOP_4_6(10,W(1,1),-5,W(1,10),-5,W(1,9),-5,W(1,2),
     $ -5,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_22,GC_23
     $ ,GC_22,GC_23,GC_5,4,1,AMPL(1,156),GOODAMP(156,H))
C     Loop amplitude for loop diagram with ID 131
      CALL LOOP_4_6(10,W(1,1),-5,W(1,9),-5,W(1,10),-5,W(1,2),
     $ -5,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_22,GC_23
     $ ,GC_22,GC_23,GC_5,4,1,AMPL(1,157),GOODAMP(157,H))
C     Loop amplitude for loop diagram with ID 132
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,7),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_5,GC_2
     $ ,GC_2,4,1,AMPL(1,158),GOODAMP(158,H))
C     Loop amplitude for loop diagram with ID 133
      CALL LOOP_4_4(1,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,8),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_5,GC_2
     $ ,GC_2,4,1,AMPL(1,159),GOODAMP(159,H))
C     Loop amplitude for loop diagram with ID 134
      CALL LOOP_4_4(1,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_2,GC_5
     $ ,GC_2,4,1,AMPL(1,160),GOODAMP(160,H))
C     Loop amplitude for loop diagram with ID 135
      CALL LOOP_4_4(1,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_2,GC_5
     $ ,GC_2,4,1,AMPL(1,161),GOODAMP(161,H))
C     Loop amplitude for loop diagram with ID 136
      CALL LOOP_4_5(8,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,7),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_5,GC_22
     $ ,GC_23,GC_2,4,1,AMPL(1,162),GOODAMP(162,H))
C     Loop amplitude for loop diagram with ID 137
      CALL LOOP_4_5(11,W(1,1),-5,W(1,2),-5,W(1,7),-5,W(1,9),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_5,GC_2
     $ ,GC_22,GC_23,4,1,AMPL(1,163),GOODAMP(163,H))
C     Loop amplitude for loop diagram with ID 138
      CALL LOOP_4_5(11,W(1,1),-5,W(1,7),-5,W(1,2),-5,W(1,9),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_2,GC_5
     $ ,GC_22,GC_23,4,1,AMPL(1,164),GOODAMP(164,H))
C     Loop amplitude for loop diagram with ID 139
      CALL LOOP_4_5(9,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,7),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_22,GC_23
     $ ,GC_5,GC_2,4,1,AMPL(1,165),GOODAMP(165,H))
C     Loop amplitude for loop diagram with ID 140
      CALL LOOP_4_5(11,W(1,1),-5,W(1,2),-5,W(1,8),-5,W(1,10),
     $ -5,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_5,GC_2
     $ ,GC_22,GC_23,4,1,AMPL(1,166),GOODAMP(166,H))
C     Loop amplitude for loop diagram with ID 141
      CALL LOOP_4_5(8,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,8),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_5,GC_22
     $ ,GC_23,GC_2,4,1,AMPL(1,167),GOODAMP(167,H))
C     Loop amplitude for loop diagram with ID 142
      CALL LOOP_4_5(9,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,8),-5
     $ ,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_22,GC_23
     $ ,GC_5,GC_2,4,1,AMPL(1,168),GOODAMP(168,H))
C     Loop amplitude for loop diagram with ID 143
      CALL LOOP_4_5(11,W(1,1),-5,W(1,8),-5,W(1,2),-5,W(1,10),
     $ -5,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_2,GC_5
     $ ,GC_22,GC_23,4,1,AMPL(1,169),GOODAMP(169,H))
C     Loop amplitude for loop diagram with ID 144
      CALL LOOP_3_3(15,W(1,1),-5,W(1,2),-5,W(1,11),-2,DCMPLX(MT)
     $ ,DCMPLX(MT),DCMPLX(MT),GC_5,GC_5,GC_37,3,1,AMPL(1,170)
     $ ,GOODAMP(170,H))
C     Loop amplitude for loop diagram with ID 145
      CALL LOOP_4_6(12,W(1,1),-5,W(1,2),-5,W(1,9),-5,W(1,10),
     $ -5,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_5,GC_22
     $ ,GC_23,GC_22,GC_23,4,1,AMPL(1,171),GOODAMP(171,H))
C     Loop amplitude for loop diagram with ID 146
      CALL LOOP_4_6(12,W(1,1),-5,W(1,2),-5,W(1,10),-5,W(1,9),
     $ -5,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_5,GC_22
     $ ,GC_23,GC_22,GC_23,4,1,AMPL(1,172),GOODAMP(172,H))
C     Loop amplitude for loop diagram with ID 147
      CALL LOOP_4_6(13,W(1,1),-5,W(1,10),-5,W(1,2),-5,W(1,9),
     $ -5,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_22,GC_23
     $ ,GC_5,GC_22,GC_23,4,1,AMPL(1,173),GOODAMP(173,H))
C     Loop amplitude for loop diagram with ID 148
      CALL LOOP_4_6(13,W(1,1),-5,W(1,9),-5,W(1,2),-5,W(1,10),
     $ -5,DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),DCMPLX(MT),GC_5,GC_22,GC_23
     $ ,GC_5,GC_22,GC_23,4,1,AMPL(1,174),GOODAMP(174,H))

c      DO I=22,26
c        AMPL(1,I)=(0.d0,0.D0)
c      ENDDO
c      DO I=149,174
c        AMPL(1,I)=(0.d0,0.D0)
c      ENDDO

C     BORN JAMPS


C     LOOP JAMPS

      DO PROC=1,3

      IF (PROC .EQ. 1) THEN !BOX ONLY

      DO K=1,3
        JAMPL(K,1)=-AMPL(K,27)+AMPL(K,1)-AMPL(K,28)-AMPL(K,29)
     $   +AMPL(K,2)-AMPL(K,30)-AMPL(K,31)+AMPL(K,3)-AMPL(K,32)
     $   -AMPL(K,33)+AMPL(K,4)-AMPL(K,34)-AMPL(K,35)-AMPL(K,36)
     $   -AMPL(K,37)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,38)-AMPL(K,39)-AMPL(K,40)
     $   -AMPL(K,41)-AMPL(K,42)-AMPL(K,43)-AMPL(K,44)-AMPL(K,45)
     $   -AMPL(K,46)-AMPL(K,47)-AMPL(K,48)-AMPL(K,49)-AMPL(K,50)
     $   -AMPL(K,51)+AMPL(K,5)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,52)-AMPL(K,53)+AMPL(K,6)
     $   -AMPL(K,54)-AMPL(K,55)+AMPL(K,7)-AMPL(K,56)-AMPL(K,57)
     $   +AMPL(K,8)-AMPL(K,58)-AMPL(K,59)-AMPL(K,60)-AMPL(K,61)
     $   -AMPL(K,62)-AMPL(K,63)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,64)-AMPL(K,65)-AMPL(K,66)
     $   -AMPL(K,67)-AMPL(K,68)-AMPL(K,69)-AMPL(K,70)-AMPL(K,71)
     $   -AMPL(K,72)-AMPL(K,73)-AMPL(K,74)-AMPL(K,75)+AMPL(K,9)
     $   -AMPL(K,76)-AMPL(K,77)
        JAMPL(K,1)=JAMPL(K,1)+AMPL(K,10)-AMPL(K,78)-AMPL(K,79)
     $   +AMPL(K,11)-AMPL(K,80)-AMPL(K,81)+AMPL(K,12)-AMPL(K,82)
     $   -AMPL(K,83)-AMPL(K,84)-AMPL(K,85)-AMPL(K,86)-AMPL(K,87)
     $   -AMPL(K,88)-AMPL(K,89)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,90)-AMPL(K,91)-AMPL(K,92)
     $   -AMPL(K,93)-AMPL(K,94)-AMPL(K,95)-AMPL(K,96)-AMPL(K,97)
     $   -AMPL(K,98)-AMPL(K,99)+AMPL(K,13)-AMPL(K,100)-AMPL(K,101)
     $   +AMPL(K,14)-AMPL(K,102)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,103)+AMPL(K,15)-AMPL(K,104)
     $   -AMPL(K,105)+AMPL(K,16)-AMPL(K,106)-AMPL(K,107)-AMPL(K,108)
     $   -AMPL(K,109)-AMPL(K,110)-AMPL(K,111)-AMPL(K,112)-AMPL(K,113)
     $   -AMPL(K,114)-AMPL(K,115)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,116)-AMPL(K,117)-AMPL(K,118)
     $   -AMPL(K,119)-AMPL(K,120)-AMPL(K,121)-AMPL(K,122)-AMPL(K,123)
     $   +AMPL(K,17)-AMPL(K,124)-AMPL(K,125)+AMPL(K,18)-AMPL(K,126)
     $   -AMPL(K,127)+AMPL(K,19)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,128)
     $   -AMPL(K,130)+AMPL(K,21)-AMPL(K,131)-AMPL(K,132)-AMPL(K,133)
     $   -AMPL(K,134)-AMPL(K,135)-AMPL(K,136)-AMPL(K,137)-AMPL(K,138)
     $   -AMPL(K,139)-AMPL(K,140)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,141)-AMPL(K,142)-AMPL(K,143)
     $   -AMPL(K,145)-AMPL(K,146)-AMPL(K,147)-AMPL(K,148)
     $   -AMPL(K,149)+AMPL(K,22)-AMPL(K,150)-AMPL(K,151)+AMPL(K,23)
     $   -AMPL(K,152)-AMPL(K,153)
        JAMPL(K,1)=JAMPL(K,1)+AMPL(K,24)-AMPL(K,154)
     $   -AMPL(K,156)+AMPL(K,26)-AMPL(K,157)-AMPL(K,158)
     $   -AMPL(K,159)-AMPL(K,160)-AMPL(K,161)-AMPL(K,162)-AMPL(K,163)
     $   -AMPL(K,164)-AMPL(K,165)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,166)-AMPL(K,167)-AMPL(K,168)
     $   -AMPL(K,169)-AMPL(K,171)-AMPL(K,172)-AMPL(K,173)
     $   -AMPL(K,174)

        BOX(K,1)=JAMPL(K,1)

      ENDDO

      RES(1) = 0.D0
      RES(2) = 0.D0
      RES(3) = 0.D0

      DO I = 1, NCOLORLOOP
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLORBORN
          ZTEMP = ZTEMP + CF(J,I)*JAMPL(1,J)
        ENDDO
        RES(1) = RES(1)+DBLE(ZTEMP*DCONJG(JAMPL(1,I))/DENOM(I))
      ENDDO


      IF (NTRY.LT.2) THEN
        DO I=1, NLOOPAMPS
          IF (SQRT(ABS(RES(1)+RES(2)+RES(3))).GT.0.D0.AND.(ABS(AMPL(1
     $     ,I)+AMPL(2,I)+AMPL(3,I))/SQRT(ABS(RES(1)+RES(2)+RES(3)))
     $     ).LT.1.0D-10) THEN
            GOODAMP(I,H)=.FALSE.
          ENDIF
        ENDDO
      ENDIF

      DO K=1,3
      BKGD_AMP(K)=RES(K)
      ENDDO

      ELSEIF (PROC .EQ. 2) THEN !SIGNAL ONLY

      DO K=1,3
        JAMPL(K,1)=-AMPL(K,129)+AMPL(K,20)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,144)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,155)+AMPL(K,25)
        JAMPL(K,1)=JAMPL(K,1)-AMPL(K,170)

        SIGNAL(K,1)=JAMPL(K,1)

      ENDDO

      RES(1) = 0.D0
      RES(2) = 0.D0
      RES(3) = 0.D0

      DO I = 1, NCOLORLOOP
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLORBORN
          ZTEMP = ZTEMP + CF(J,I)*JAMPL(1,J)
        ENDDO
        RES(1) = RES(1)+DBLE(ZTEMP*DCONJG(JAMPL(1,I))/DENOM(I))
      ENDDO


      IF (NTRY.LT.2) THEN
        DO I=1, NLOOPAMPS
          IF (SQRT(ABS(RES(1)+RES(2)+RES(3))).GT.0.D0.AND.(ABS(AMPL(1
     $     ,I)+AMPL(2,I)+AMPL(3,I))/SQRT(ABS(RES(1)+RES(2)+RES(3)))
     $     ).LT.1.0D-10) THEN
            GOODAMP(I,H)=.FALSE.
          ENDIF
        ENDDO
      ENDIF

      DO K=1,3
      SIGNAL_AMP(K)=RES(K)
      ENDDO

      ELSEIF (PROC .EQ. 3) THEN !EVERYTHING

      DO K=1,3
        JAMPL(K,1)=BOX(K,1)+SIGNAL(K,1)
      ENDDO

      RES(1) = 0.D0
      RES(2) = 0.D0
      RES(3) = 0.D0

      DO I = 1, NCOLORLOOP
        ZTEMP = (0.D0,0.D0)
        DO J = 1, NCOLORBORN
          ZTEMP = ZTEMP + CF(J,I)*JAMPL(1,J)
        ENDDO
        RES(1) = RES(1)+DBLE(ZTEMP*DCONJG(JAMPL(1,I))/DENOM(I))
      ENDDO


      IF (NTRY.LT.2) THEN
        DO I=1, NLOOPAMPS
          IF (SQRT(ABS(RES(1)+RES(2)+RES(3))).GT.0.D0.AND.(ABS(AMPL(1
     $     ,I)+AMPL(2,I)+AMPL(3,I))/SQRT(ABS(RES(1)+RES(2)+RES(3)))
     $     ).LT.1.0D-10) THEN
            GOODAMP(I,H)=.FALSE.
          ENDIF
        ENDDO
      ENDIF

      ENDIF
      ENDDO

      END

