      SUBROUTINE MPLOOPNUM(Q,RES)
C     
C     ARGUMENTS 
C     
      INCLUDE 'cts_mprec.h'
      INCLUDE 'cts_mpc.h'                                             
     $ , INTENT(IN), DIMENSION(0:3) :: Q
      INCLUDE 'cts_mpc.h'                                             
     $ , INTENT(OUT) :: RES
C     
C     LOCAL VARIABLES 
C     
      COMPLEX*16 DRES
      COMPLEX*16 DQ(0:3)
      INTEGER I
C     ----------
C     BEGIN CODE
C     ----------
      DO I=0,3
        DQ(I) = Q(I)
      ENDDO

      CALL LOOPNUM(DQ,DRES)
      RES=DRES

      END

C     THE CORE SUBROUTINE CALLED BY CUTTOOLS WHICH CONTAINS THE HELAS
C      CALLS BUILDING THE LOOP

      SUBROUTINE LOOPNUM(QCT,RES)
C     
C     CONSTANTS 
C     
      INTEGER    NEXTERNAL
      PARAMETER (NEXTERNAL=6)
      INTEGER    MAXLCOUPLINGS
      PARAMETER (MAXLCOUPLINGS=6)
      INTEGER    NMAXLOOPWFS
      PARAMETER (NMAXLOOPWFS=(NEXTERNAL+2))
      REAL*8     ZERO
      PARAMETER (ZERO=0.D0)
C     
C     ARGUMENTS 
C     
      COMPLEX*16 QCT(0:3),Q(0:3)
      COMPLEX*16 RES
C     
C     LOCAL VARIABLES 
C     
      COMPLEX*16 BUFF(12)
      COMPLEX*16 WL(20,NMAXLOOPWFS)
      INTEGER I
C     
C     GLOBAL VARIABLES
C     
      COMPLEX*16 WE(20,NEXTERNAL)
      COMPLEX*16 LC(MAXLCOUPLINGS)
      COMPLEX*16 ML(NEXTERNAL+2)
      INTEGER ID, SYMFACT
      COMMON/LOOP/WE,LC,ML,ID,SYMFACT
C     ----------
C     BEGIN CODE
C     ----------
      RES=(0.D0,0.D0)
      DO I=0,3
        Q(I)=-QCT(I)
      ENDDO
      IF (ID.EQ.1) THEN
C       Loop diagram number 1 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV1L_1(WL(1,3),WE(1,2),LC(2),ML(4),ZERO,WL(1,4))
          CALL FFV1L_1(WL(1,4),WE(1,3),LC(3),ML(5),ZERO,WL(1,5))
          CALL FFV1L_1(WL(1,5),WE(1,4),LC(4),ML(6),ZERO,WL(1,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.2) THEN
C       Loop diagram number 3 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV1L_1(WL(1,3),WE(1,2),LC(2),ML(4),ZERO,WL(1,4))
          CALL FFV2L_3_1(WL(1,4),WE(1,3),LC(3),LC(4),ML(5),ZERO,WL(1
     $     ,5))
          CALL FFV1L_1(WL(1,5),WE(1,4),LC(5),ML(6),ZERO,WL(1,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.3) THEN
C       Loop diagram number 4 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV2L_3_1(WL(1,3),WE(1,2),LC(2),LC(3),ML(4),ZERO,WL(1
     $     ,4))
          CALL FFV1L_1(WL(1,4),WE(1,3),LC(4),ML(5),ZERO,WL(1,5))
          CALL FFV1L_1(WL(1,5),WE(1,4),LC(5),ML(6),ZERO,WL(1,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.4) THEN
C       Loop diagram number 7 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV2L_3_1(WL(1,3),WE(1,2),LC(2),LC(3),ML(4),ZERO,WL(1
     $     ,4))
          CALL FFV2L_3_1(WL(1,4),WE(1,3),LC(4),LC(5),ML(5),ZERO,WL(1
     $     ,5))
          CALL FFV1L_1(WL(1,5),WE(1,4),LC(6),ML(6),ZERO,WL(1,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.5) THEN
C       Loop diagram number 14 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV1L_1(WL(1,3),WE(1,2),LC(2),ML(4),ZERO,WL(1,4))
          CALL FFV1L_1(WL(1,4),WE(1,3),LC(3),ML(5),ZERO,WL(1,5))
          CALL FFV2L_3_1(WL(1,5),WE(1,4),LC(4),LC(5),ML(6),ZERO,WL(1
     $     ,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.6) THEN
C       Loop diagram number 21 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV1L_1(WL(1,3),WE(1,2),LC(2),ML(4),ZERO,WL(1,4))
          CALL FFV2L_3_1(WL(1,4),WE(1,3),LC(3),LC(4),ML(5),ZERO,WL(1
     $     ,5))
          CALL FFV2L_3_1(WL(1,5),WE(1,4),LC(5),LC(6),ML(6),ZERO,WL(1
     $     ,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.7) THEN
C       Loop diagram number 23 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV2L_3_1(WL(1,3),WE(1,2),LC(2),LC(3),ML(4),ZERO,WL(1
     $     ,4))
          CALL FFV1L_1(WL(1,4),WE(1,3),LC(4),ML(5),ZERO,WL(1,5))
          CALL FFV2L_3_1(WL(1,5),WE(1,4),LC(5),LC(6),ML(6),ZERO,WL(1
     $     ,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.8) THEN
C       Loop diagram number 27 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV1L_1(WL(1,3),WE(1,2),LC(2),ML(4),ZERO,WL(1,4))
          CALL FFV2L_5_1(WL(1,4),WE(1,3),LC(3),LC(4),ML(5),ZERO,WL(1
     $     ,5))
          CALL FFV1L_1(WL(1,5),WE(1,4),LC(5),ML(6),ZERO,WL(1,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.9) THEN
C       Loop diagram number 28 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV2L_5_1(WL(1,3),WE(1,2),LC(2),LC(3),ML(4),ZERO,WL(1
     $     ,4))
          CALL FFV1L_1(WL(1,4),WE(1,3),LC(4),ML(5),ZERO,WL(1,5))
          CALL FFV1L_1(WL(1,5),WE(1,4),LC(5),ML(6),ZERO,WL(1,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.10) THEN
C       Loop diagram number 31 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV2L_5_1(WL(1,3),WE(1,2),LC(2),LC(3),ML(4),ZERO,WL(1
     $     ,4))
          CALL FFV2L_5_1(WL(1,4),WE(1,3),LC(4),LC(5),ML(5),ZERO,WL(1
     $     ,5))
          CALL FFV1L_1(WL(1,5),WE(1,4),LC(6),ML(6),ZERO,WL(1,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.11) THEN
C       Loop diagram number 38 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV1L_1(WL(1,3),WE(1,2),LC(2),ML(4),ZERO,WL(1,4))
          CALL FFV1L_1(WL(1,4),WE(1,3),LC(3),ML(5),ZERO,WL(1,5))
          CALL FFV2L_5_1(WL(1,5),WE(1,4),LC(4),LC(5),ML(6),ZERO,WL(1
     $     ,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.12) THEN
C       Loop diagram number 45 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV1L_1(WL(1,3),WE(1,2),LC(2),ML(4),ZERO,WL(1,4))
          CALL FFV2L_5_1(WL(1,4),WE(1,3),LC(3),LC(4),ML(5),ZERO,WL(1
     $     ,5))
          CALL FFV2L_5_1(WL(1,5),WE(1,4),LC(5),LC(6),ML(6),ZERO,WL(1
     $     ,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.13) THEN
C       Loop diagram number 47 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV2L_5_1(WL(1,3),WE(1,2),LC(2),LC(3),ML(4),ZERO,WL(1
     $     ,4))
          CALL FFV1L_1(WL(1,4),WE(1,3),LC(4),ML(5),ZERO,WL(1,5))
          CALL FFV2L_5_1(WL(1,5),WE(1,4),LC(5),LC(6),ML(6),ZERO,WL(1
     $     ,6))
          BUFF(I)=WL(I,6)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.14) THEN
C       Loop diagram number 103 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFS1L_1(WL(1,3),WE(1,2),LC(2),ML(4),ZERO,WL(1,4))
          CALL FFV1L_1(WL(1,4),WE(1,3),LC(3),ML(5),ZERO,WL(1,5))
          BUFF(I)=WL(I,5)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ELSEIF (ID.EQ.15) THEN
C       Loop diagram number 118 (might be others, just an example)
        DO I=1,4
          CALL LCUT_F(Q(0),I,WL(1,2))
          CALL FFV1L_1(WL(1,2),WE(1,1),LC(1),ML(3),ZERO,WL(1,3))
          CALL FFV1L_1(WL(1,3),WE(1,2),LC(2),ML(4),ZERO,WL(1,4))
          CALL FFS1L_1(WL(1,4),WE(1,3),LC(3),ML(5),ZERO,WL(1,5))
          BUFF(I)=WL(I,5)
        ENDDO
        CALL CLOSE_4(BUFF(1),RES)
      ENDIF
      RES=RES/SYMFACT
      END

