      subroutine chooser
c---- Note added 4/21/03
c---- plabel set to 'ig' (for 'ignore') means that this
c---- particle should not be subject to any cuts, so that the
c---- total cross-section comes out correctly when the BR is removed
      implicit none
      include 'constants.f'
      include 'masses.f'
      include 'ewcharge.f'
      include 'zcouple.f'
      include 'vegas_common.f'
      include 'zerowidth.f'
      include 'removebr.f'
      include 'bbproc.f'
      include 'nwz.f'
      include 'process.f'
      include 'flags.f'
      include 'heavyflav.f'
      include 'nflav.f'
      include 'nodecay.f'
      include 'stopscales.f'
      include 'scale.f'
      include 'facscale.f'
      include 'nlooprun.f'
      include 'b0.f'
      include 'colstruc.f'
      include 'stopbmass.f'
      include 'fourthgen.f'
      include 'anomcoup.f'
      include 'srdiags.f'
      include 'clustering.f'
      include 'frag.f'
      character*4 part
      common/part/part
      double precision wwbr,zzbr,tautaubr,gamgambr,Rcut,Rbbmin,
     . alphas,amz,cmass,bmass
      double precision br,BrnRat,brwen,brzee,brznn,brtau,brtop,brcharm
      double precision mass2,width2,mass3,width3
      common/breit/n2,n3,mass2,width2,mass3,width3
      integer nproc,mproc,j,n2,n3,nqcdjets,nqcdstart,isub,notag,imhq
      character*83 pname
      character*1 order
      character*2 plabel(mxpart)
      character*72 string
      character*30 runstring
      double precision f0q,f2q,f4q
      double precision Vud,Vus,Vub,Vcd,Vcs,Vcb
      common/cabib/Vud,Vus,Vub,Vcd,Vcs,Vcb
      common/bitflags/f0q,f2q,f4q
      common/Rbbmin/Rbbmin
      common/Rcut/Rcut
      common/runstring/runstring
      common/nproc/nproc
      common/BrnRat/BrnRat
      common/nqcdjets/nqcdjets,nqcdstart
      common/plabel/plabel
      common/isub/isub
      common/notag/notag
      common/couple/amz
      common/qmass/cmass,bmass

      do j=1,mxpart
      plabel(j)=''
      enddo

c---  for ZZlept: nrpoc = 81
c---  for WWlept: nproc = 61

      if (nproc .eq. 81) then

      write(6,*) 'Chooser:process chosen by nproc=',nproc


      mproc=81
      pname='  f(p1)+f(p2) --> Z^0(-->mu^-(p3)+mu^+(p4)) + Z^0(-->e^-(p5)+e^
     &+(p6))'      
      order='N'

      if (mproc .eq. nproc) go to 42

 42   write(6,*)
      write(6,*) '*************************** f(p1)+f(p2) --> *****'//
     . '********************'
      write(6,*) '* ',pname(19:83),' *'
      write(6,*) '*************************************************'//
     . '********************'
      write(6,*)

      elseif (nproc .eq. 61) then

      write(6,*) 'Chooser:process chosen by nproc=',nproc


      mproc=61
      pname='  f(p1)+f(p2) --> W^+(-->nu(p3)+e^+(p4)) +W^-(-->e^-(p5)+nu~(p6
     $))'
      order='N'

      if (mproc .eq. nproc) go to 444

 444  write(6,*)
      write(6,*) '*************************** f(p1)+f(p2) --> *****'//
     . '********************'
      write(6,*) '* ',pname(19:83),' *'
      write(6,*) '*************************************************'//
     . '********************'
      write(6,*)

      endif
      
      
      plabel(1)='pp'
      plabel(2)='pp'

c--- the default behaviour is to remove no branching ratio
      BrnRat=1d0

C      go to 662
c--- set up most parameters
      call coupling

      notag=0
      nqcdjets=0
      isub=0
      bbproc=.false.
      nodecay=.false.
      nfonly=.false.
      caonly=.false.
      fourthgen=.false.
      rescale=.false.

c-- Rbbmin is an additional variable, added so that the separation
c-- between two b jets can be controlled separately from the Delta_R
c-- cut between any other types of jet
c-- Default behaviour: the same value as for the other jets
      Rbbmin=Rcut

      if (nproc .eq. 81) then      
c-----------------------------------------------------------------------

        case='ZZlept'
c        call sethparams(br,wwbr,zzbr,tautaubr,gamgambr)
        call readcoup
        call checkminzmass(1)
        call checkminzmass(2)
        call readcoup
        plabel(7)='pp'
        nqcdjets=0
        nwz=0
        ndim=10
        mb=0
        n2=1
        n3=1
        mass2=zmass
        width2=zwidth
        mass3=zmass
        width3=zwidth
        q1=-1d0
        l1=le
        r1=re

c--- only include singly-resonant diagrams when not in zerowidth approx.        
	if (zerowidth) then
	  srdiags=.false.
	else
	  srdiags=.true.
	endif
	
c--  81 '  f(p1)+f(p2) --> Z^0(-->mu^-(p3)+mu^+(p4)) + Z^0(-->e^-(p5)+e^+(p6))'
c--     '  f(p1)+f(p2) --> Z^0 + Z^0 (for total Xsect)' (removebr=.true.)
c--  86 '  f(p1)+f(p2) --> Z^0(-->e^-(p5)+e^+(p6))+Z^0(-->mu^-(p3)+mu^+(p4)) (NO GAMMA*)'
c--     '  f(p1)+f(p2) --> Z^0 + Z^0 (for total Xsect) (NO GAMMA*)' (removebr=.true.)
          plabel(3)='el' 
          plabel(4)='ea'
          plabel(5)='ml'
          plabel(6)='ma'
          q2=-1d0
          l2=le
          r2=re	
          l1=le
          r1=re

C--------- if no gamma, q1=q2=0
C          write(*,*) '*********************************'
C          write(*,*) '*     NO GAMMA CONTRIBUTION     *'
C          write(*,*) '*********************************'
C          q1=0d0
C          q2=0d0


      elseif (nproc .eq. 61) then
c------------------------------------------------------------------------      

        case='WWqqbr'
        call readcoup
        nqcdjets=0
        plabel(7)='pp'
        nwz=1
        ndim=10
        mb=0d0
        n2=1
        n3=1
        mass2=wmass
        width2=wwidth
        mass3=wmass
        width3=wwidth

c--- include singly resonant diagrams if zerowidth=.false. , but only
c---  as long as anomtgc=.false. too
        srdiags=((zerowidth .eqv. .false.)
     &     .and. ( anomtgc  .eqv. .false.))

c--- zero srdiags for CDFdijet calculation 
c        if(runstring(1:10).eq.'cdf_Wdijet') then 
c           srdiags=.false.
c        endif

          plabel(3)='nl'
          plabel(4)='ea'
          plabel(5)='el'
          plabel(6)='na'
          l1=1d0

      endif

c------------------------------------------------------------------------      
c--- set up alpha-s again (in case nflav was changed)
C      call coupling2

c--- remove 2 dimensions from integration if decay is not included
      if (nodecay) ndim=ndim-2

c--- report on the removed BR, if necessary
      if (removebr) then
        write(6,*)'****************************************************'
        write(6,98) BrnRat
        write(6,*)'****************************************************'
      endif

c--- check that calculation can be performed
      call checkorder(order)

c--- fill up CKM matrix
      call ckmfill(nwz)

662   continue
      return

 43   write(6,*) 'problems opening process.DAT'
      stop

 44   write(6,*) 'Unimplemented process number, nproc = ',nproc, 
     . ' mcfm halted'
      stop
 
 98   format(' *             Brn.Rat. removed = ',  f11.7, '       *')
     
      end

      
      subroutine checkminzmass(i)
c--- Checks that the minimum invariant mass specified in the options
c--- file is not zero for boson 34 (i=1) or boson 56 (i=2)
      implicit none
      include 'limits.f'
      include 'zerowidth.f'
      integer i

c--- if generating exactly on-shell, there's nothing to worry about      
      if (zerowidth) return
      
      if ((i .eq. 1) .and. (wsqmin .eq. 0d0)) then
        write(6,*)
        write(6,*) 'Please set m34min not equal to zero to'
        write(6,*) 'prevent the virtual photon from becoming real.'
        stop
      endif

      if ((i .eq. 2) .and. (bbsqmin .eq. 0d0)) then
        write(6,*)
        write(6,*) 'Please set m56min not equal to zero to'
        write(6,*) 'prevent the virtual photon from becoming real.'
        stop
      endif
      
      return
      end
      
      
