      block data codeversion_data
      implicit none
      include 'codeversion.f'
      data codeversion/'6.1'/
      data      prelim/.false./      ! if true, print warning message
      end

      subroutine mcfm_init
************************************************************************
*                                                                      *
*  This routine should initialize any necessary variables and          *
*  perform the usual print-outs                                        *
*                                                                      *
************************************************************************
      implicit none
      include 'constants.f'
      include 'cutoff.f'
      include 'limits.f'
      include 'npart.f'
      include 'phasemin.f'
      include 'facscale.f'
      include 'scale.f'
      include 'verbose.f'
      include 'codeversion.f'
      character*50 line
      integer vlength,lenocc
C -- GZ
      include 'first_time.f'
      double precision rtsmin,sqrts,p1ext(4),p2ext(4),
     . p(mxpart,4),val
      integer j,k
      common/rtsmin/rtsmin
      common/energy/sqrts
      common/pext/p1ext,p2ext
      data p/mxpart*3d0,mxpart*4d0,mxpart*0d0,mxpart*5d0/

* Welcome banner
C      call banner
      line='**************************************************'
      vlength=lenocc(codeversion)
      vlength=vlength+17
      line(25-vlength/2:24+(vlength+1)/2)=
     . ' MCFM - version '//codeversion//' '

      write(6,*) line

      write(6,*) '*                                                *'
      write(6,*) '* MCFM, v'//codeversion//
     .                          '              October 17th, 2011  *'
      write(6,*) '*                                                *'
      write(6,*) '* Authors: John Campbell, Keith Ellis,           *'
      write(6,*) '*          Ciaran Williams                       *'
      write(6,*) '*         (johnmc@fnal.gov, ellis@fnal.gov,      *'
      write(6,*) '*          ciaran@fnal.gov)                      *'
      write(6,*) '*                                                *'
      write(6,*) '* For details see:                               *'
      write(6,*) '*                                                *'
      write(6,*) '*  arXiv:1107.5569 [hep-ph]  (gg->WW,Higgs intf) *'
      write(6,*) '*  arXiv:1105.0020 [hep-ph]  (diboson update)    *'
      write(6,*) '*  JHEP 1103:027(2011), arXiv:1011.6647 (Wbb)    *'
      write(6,*) '*       (with S. Badger)                         *'
      write(6,*) '*  Phys.Rev.D81:074023, arXiv:1001.4495 (H+2jet) *'
      write(6,*) '*                                                *'
      write(6,*) '*  P.R.L. 102:142001, arXiv:0903.0005 [hep-ph]   *'
      write(6,*) '*    (t-channel single top + explicit b,         *'
      write(6,*) '*      JC, R.Frederix, F.Maltoni, F.Tramontano)  *'
      write(6,*) '*  N.P.B 726:109(2005), hep-ph/0506289 (W+t)     *'
      write(6,*) '*  Phys.Rev.D70:094012, hep-ph/0408158 (Sngl Top)*'
      write(6,*) '*       (with Francesco Tramontano)              *'
      write(6,*) '*                                                *'
      write(6,*) '*  Phys.Rev.D65:113007, hep-ph/0202176 (W,Z+2j)  *'
      write(6,*) '*  Phys.Rev.D62:114012, hep-ph/0006304 (W,Z+bb)  *'
      write(6,*) '*  Phys.Rev.D60:113006, hep-ph/9905386 (diboson) *'
      write(6,*) '*                                                *'
      write(6,*) '* On the web:  http://mcfm.fnal.gov/             *'
      write(6,*) '**************************************************'
      write(6,*)

      call reader_input

      first_time = .true. 
      
      if (verbose) then
      write(6,*)
      write(6,*) '****************************************'
      write(6,*) '*     Cross section in femtobarns      *'
      write(6,*) '****************************************'
      write(6,*)
      endif

* Set-up incoming beams and PS integration cut-offs
      rtsmin=min(rtsmin,dsqrt(wsqmin+cutoff))
      rtsmin=min(rtsmin,dsqrt(bbsqmin+cutoff))
      taumin=(rtsmin/sqrts)**2
      xmin=1d-8

      p1ext(4)=-half*sqrts
      p1ext(1)=0d0
      p1ext(2)=0d0
      p1ext(3)=-half*sqrts

      p2ext(4)=-half*sqrts
      p2ext(1)=0d0
      p2ext(2)=0d0
      p2ext(3)=+half*sqrts

* Set-up run name

* Initialize all histograms
* npart=9 is a dummy value, to ensure that all histograms are included
      npart=9
      val=1d-15   
       
      do j=1,mxpart
      do k=1,4
      p(j,k)=0d0
      enddo
      enddo 

      return
      end
            
