      subroutine re_weight(sfnum,kevent,sum,maxwgt,xerr)

      implicit none

c
c     Constants
c
      include 'run_config.inc'
      integer    maxsubprocesses
      parameter (maxsubprocesses=9999)
      integer    cmax_events
      parameter (cmax_events=500000)
      integer    sfnum
      include 'maxparticles.inc'
      integer    maxexternal
      parameter (maxexternal=2*max_particles-3)

      double precision zero
      parameter       (ZERO = 0d0)

c     
c     Local
c
      character*300 subname(maxsubprocesses)
      character*310 pathsubname(maxsubprocesses)         !needed for MadWeight
      character*80 down_path                           !needed for MadWeight
      character*40 filename                         !needed for MadWeight
      character*4  card_number                         !needed for MadWeight
      character*20 run_name                            !needed for MadWeight
      integer pos1,pos2,pos3                           ! needed for MadWeight
      integer i,j,k,m,ns,nreq,ievent
      integer kevent,revent,iarray(cmax_events)
      double precision sum, xsec, xerr, goal_wgt,xarray(cmax_events)
      integer i4,r8,record_length
      integer iseed 
      real xran1
      double precision wgt,maxwgt
      double precision p(0:4,maxexternal)
      integer ic(7,maxexternal),n
      double precision scale,aqcd,aqed
      character*20 param(maxpara),value(maxpara)
      integer npara,nunwgt
      double precision xtrunc, min_goal,max_goal
      logical keep(cmax_events),done
      integer ntry
      logical gridrun,gridpack

      character*140 buff
      
      data iseed/-1/

      include 'nexternal.inc'
c--masses
      double precision pmass(nexternal)
      common/to_mass/  pmass

      double precision pp(0:3,nexternal),born(2),loop(3),PIJ
      character*5 a

      include 'coupl.inc'
      DOUBLE PRECISION PI
      PARAMETER  (PI=3.141592653589793D0)

c-----   
c  Begin Code
c-----

      call setpara('param_card.dat',.true.)   !Sets up couplings and masses
      include 'pmass.inc'
      call printout
      
      write(*,*) '***********************'
      write(*,*) '* reweighting started *'
      write(*,*) '***********************'

c---- Initialization 
      sum=0D0
      maxwgt=0D0
      xerr=0D0  
   
c---- reweighting events
      do i=1,kevent
         read(sfnum,rec=i) wgt,n,
     &        ((ic(m,j),j=1,maxexternal),m=1,7),ievent,
     &        ((p(m,j),m=0,4),j=1,maxexternal),scale,aqcd,aqed,
     &     buff

c        correct the gluon(quark) ID
         ic(1,1)=21
         ic(6,1)=-1
         ic(1,2)=21
         ic(6,2)=-1

         call map_to_pext(p,pp,n,ic)

c         if (i .lt. 10) then

         if (PIJ(pp,3,4) .lt. 0.5D0) then

           wgt=0.d0
           read(buff,*) a,born(1),born(2)
           write(buff,'(a,5e15.7)')
     $ '#',born(1),born(2),0d0,0d0,0d0

         else

           read(buff,*) a,born(1),born(2)
           call SLOOPMATRIX(PP,LOOP) 
           LOOP(1)=LOOP(1)*(aqcd/G**2*4.D0*PI)**2
           LOOP(2)=LOOP(2)*(aqcd/G**2*4.D0*PI)**2
           LOOP(3)=LOOP(3)*(aqcd/G**2*4.D0*PI)**2
c         write(*,*) i,born(1),born(2),LOOP(1),LOOP(2),LOOP(3)
c     & ,born(2)/LOOP(3)
c         do j=1,6
c           write(*,*) (pp(k,j),k=0,3)
c         enddo
            write(buff,'(a,5e15.7)') 
     $ '#',born(1),born(2),LOOP(1),LOOP(2),LOOP(3)
            wgt=wgt*loop(1)/(born(1)+born(2))

          endif !pt cut
c         endif ! nevents lt 10

         sum=sum+wgt
         maxwgt=max(maxwgt,wgt)
         xerr=xerr+wgt**2

         write(sfnum,rec=i) wgt,n,
     &        ((ic(m,j),j=1,maxexternal),m=1,7),ievent,
     &        ((p(m,j),m=0,4),j=1,maxexternal),scale,aqcd,aqed,
     &     buff

      enddo 

      xerr=sqrt(xerr)

      write(*,*) ' ' 
      write(*,*) '****************************************'
      write(*,*) '* sum     =',sum,' *'
      write(*,*) '* err     =',xerr,' *'
      write(*,*) '* max wgt =',maxwgt,' *'
      write(*,*) '****************************************'

      return
      end


      subroutine map_to_pext(p,pp,n,ic)

      implicit none

      include 'maxparticles.inc'
      integer    maxexternal
      parameter (maxexternal=2*max_particles-3)

      include 'nexternal.inc'
      double precision p(0:4,maxexternal),pp(0:3,nexternal)
      integer ic(7,maxexternal),n,l,i,k

            l=0
            do i=1,n
               if(abs(ic(6,i)).eq.1) then
                  l=l+1
                  do k=0,3    
                     pp(k,l)=p(k,i)
                  enddo
               endif
            enddo


      return
      end
