C**************************************************************************
C     THIS IS A SIMPLE PROGRAM FOR REWEIGHTING EVENTS
C     Fabio Maltoni - 23 JULY 2011 
C**************************************************************************
      IMPLICIT NONE
C     
C     CONSTANTS  
C     
      REAL*8 ZERO
      PARAMETER (ZERO=0D0)
      INTEGER MAXPARTICLES
      PARAMETER (MAXPARTICLES=50)
      include "nexternal.inc"
!---  particle masses              
      REAL*8 PMASS(NEXTERNAL)
c     
c     Local
c     
      integer ic(7,MAXPARTICLES),ictemp(MAXPARTICLES)
      double precision P(0:4,MAXPARTICLES)
      double precision PP(0:3,NEXTERNAL)
      real*8 wgt,wgt2,totwgt,totwgt2,PI,std,cxn,error
      integer i,j,l,k,m,ievent,nevents,nparticles,nfiles 
      double precision scale,aqcd,aqed,mat1,mat2,MATELEM(3),BORN
     & ,MCFM_BKGD,MG_SIGNAL
      logical done,found,more_files
      character*170 filenamein,filenameout,filename
      character*140 buff,buff2,a
      parameter (PI=3.14159265d0)
      include 'coupl.inc'
C-----
C     BEGIN CODE
C-----
C           
      
      cxn=0d0
      error=0d0
      nfiles=0

C-
C-start reading the files
C-
      
        read(*,'(a)',end=90) filenamein
        read(*,'(a)',end=90) filenameout
        nfiles=nfiles + 1
      
        filename=filenamein
        open(unit=15, file = filename, status = 'unknown'    , err=80)
    
        filename=filenameout
        open(unit=25, file = filename, status = 'unknown', err=80)
 
c        filename='Cards/param_card.dat'
c        open(unit=99, file = filename, status = 'unknown', err=80)

C 
C-first cp the banner in the event file
C
        filename=filenamein

c        do while(index(buff,"<event") .eq. 0) 
c          read(15,'(a140)',end=80,err=80) buff
c          if(index(buff,"<event") .eq. 0) write(25,'(a140)') buff
c        enddo
c        rewind(15)

C 
C-read the param_card.dat from the banner of the event file
C
c          read(15,'(a140)',end=80,err=80) buff
c          do while(index(buff,"<slha") .eq. 0)
c            read(15,'(a140)',end=80,err=80) buff
c          enddo

c          do while(index(buff,"</slha") .eq. 0)
c            read(15,'(a140)',end=80,err=80) buff
c            write(99,'(a140)') buff
c          enddo
c          close(99)
c          rewind(15)
          
C 
C-now we can set the parameters
C
C          call setpara('param_card.dat',.true.)  !now call the param_card.dat to setup the paramaters
          call setpara('param_card.dat')  !first call to setup the paramaters
          include "pmass.inc"             !set up masses
          call printout()


C 
C-start the reweighting event by event
C
        nevents=0
        done=.false.
        totwgt=0d0
        totwgt2=0d0
        std=0d0
        do while (.not. done)
          call read_event(15,P,wgt,nparticles,ic,ievent,scale,aqcd,aqed,buff,done)
          if (.not. done) then
C--find the external momenta and map them into PP(0:3,nexternal)
            l=0
            do i=1,nparticles
               if(abs(ic(6,i)).eq.1) then
                  l=l+1
                  do k=0,3
                     PP(k,l)=P(k,i)
                  enddo
               endif
            enddo
c--now calculate the old m2 and the new m2 
            CALL SLOOPMATRIX(PP,MATELEM)
            MATELEM(1)=MATELEM(1)/(G**2/4d0/PI)**2*aqcd**2
            MATELEM(2)=MATELEM(2)/(G**2/4d0/PI)**2*aqcd**2
            MATELEM(3)=MATELEM(3)/(G**2/4d0/PI)**2*aqcd**2
            read(buff,*) a,MCFM_BKGD
c            write(*,'(a)') buff
            write(buff,'(a,3e15.7)') '#',MCFM_BKGD,MATELEM(1),MATELEM(2)
            wgt2=wgt
c            wgt2=wgt/MCFM_BKGD*MATELEM(1)
c            write(*,'(a,3e15.7)') '#',MATELEM(1)/MCFM_BKGD
c     & ,MATELEM(1)/mat1

            
            call write_event(25,P,wgt2,nparticles,ic,ievent,scale,aqcd,aqed,buff,done)

            nevents = nevents + 1
            totwgt=totwgt+wgt
            totwgt2=totwgt2+wgt2
            std = std + wgt2**2

          endif
          if(mod(nevents,100).eq.0) print *,'At event ',nevents
c          if(mod(nevents,10).eq.0) STOP
        enddo !done=true, end of event file

        std = dsqrt(std-totwgt2**2/nevents)
        cxn=cxn+totwgt2/std**2
        error=error+1/std**2

        write(*,*) "reweighted ",nevents, " events"
        write(*,*) "total weight before : ", totwgt
        write(*,*) "total weight after  : ", totwgt2
        write(*,*) "std                 : ", std
        write(*,*) "  "
        write(*,*) "cxn_best            : ", cxn/error
        write(*,*) "error best          : ", 1d0/dsqrt(error)
        write(*,*) "------------------",nfiles,"-------------------------"

        close(15) !close event file
        close(25) !close reweighted event file

        go to 99
90      more_files=.false.
99      continue
      
      goto 100
 80   write (*,*) "i/o error : ",filename
 100  continue
      end
