      subroutine reader_input
************************************************************************
*   Routine to read in the file input.DAT, which is a consolidated     *
*   form of all the input files and new to version 3.4 of MCFM         *
************************************************************************
      implicit none
      include 'constants.f'
      include 'debug.f'
      include 'new_pspace.f'
      include 'virtonly.f'
      include 'realonly.f'
      include 'noglue.f'
      include 'realwt.f'
      include 'lc.f'
      include 'cutoff.f'
      include 'maxwt.f'
      include 'masses.f'
      include 'process.f'
      include 'scale.f'
      include 'facscale.f'
      include 'dynamicscale.f'
      include 'zerowidth.f'
      include 'removebr.f'
      include 'flags.f'
      include 'clustering.f'
      include 'anomcoup.f'
      include 'gridinfo.f'
      include 'verbose.f'
      include 'limits.f'
      include 'workdir.f'
      include 'jetcuts.f'
      include 'leptcuts.f'
      include 'lhapdf.f'
      include 'alfacut.f'
      include 'betacut.f'
      include 'pdlabel.f'
      include 'qcdcouple.f'
      include 'nlooprun.f'
      include 'initialscales.f'
      include 'stopscales.f'
      include 'vanillafiles.f'
      include 'frag.f'
      include 'outputoptions.f'
      character*72 inputfile,getinput
      character*90 line
      character*4 part
      character*30 runstring
      integer nargs,lenocc,lenarg
      logical spira
      logical creatent,dswhisto,dryrun,makecuts
      integer nmin,nmax,n2,n3
      integer nproc,ih1,ih2,itmx1,itmx2,ncall1,ncall2,idum,origij
      integer NPTYPE,NGROUP,NSET
      double precision rtsmin,sqrts,factor
      double precision mbbmin,mbbmax,Mwmin,Mwmax
      double precision Rcut
      logical technicalincluded
      double precision ran2,randummy
      double precision cmass,bmass
      double precision mass2,width2,mass3,width3
      double precision amz,alphas
      
      common/couple/amz
      
      common/breit/n2,n3,mass2,width2,mass3,width3
      
      common/spira/spira
      common/nmin/nmin
      common/nmax/nmax
      common/rtsmin/rtsmin
 
      common/outputflags/creatent,dswhisto      

      common/nproc/nproc
      common/part/part
      common/runstring/runstring
      common/energy/sqrts
      common/density/ih1,ih2
      common/iterat/itmx1,ncall1,itmx2,ncall2
      common/ranno/idum
      common/dryrun/dryrun
      
      common/pdflib/NPTYPE,NGROUP,NSET
      
      common/Rcut/Rcut
      common/makecuts/makecuts

      common/qmass/cmass,bmass

      common/origij/origij

      save /ranno/
      
      verbose=.true.

c--- work out the name of the input file and open it

C      nargs=iargc()
C      if (nargs .ge. 1) then
C        call getarg(1,inputfile)
C      else
        inputfile='input.DAT'
C      endif
      
C      lenarg=lenocc(inputfile)

C      if ((lenarg.lt.4).or.(inputfile(lenarg-3:lenarg).ne.'.DAT')) then
C        workdir=inputfile
c--- truncate if the directory / is included
C        if (workdir(lenarg:lenarg) .eq. '/') then
C           workdir(lenarg:lenarg)=' '
C           lenarg=lenarg-1
C        endif
C        if (nargs .ge. 2) then
c          call getarg(2,getinput)
c          inputfile=workdir(1:lenarg)//'/'//getinput
C        else  
C          inputfile=workdir(1:lenarg)//'/input.DAT'
C        endif
C      else
C        workdir=''
C      endif
      
      write(6,*) '* Using input file named ',inputfile

C      open(unit=20,file=inputfile,status='old',err=999)
C      call checkversion(20,inputfile)

c--- read-in the user inputs

      if (verbose) write(6,*)
C      read(20,99) line
c--- write-out comment line
C      read(20,99) line
C      if (verbose) write(6,*) '* ',line
c--- flags for the mode of MCFM   
      evtgen=.false.
      if (verbose) call writeinput(6,' * ',' ','evtgen')
      creatent=.false.
      if (verbose) call writeinput(6,' * ',' ','creatent')
      skipnt=.false.
      if (verbose) call writeinput(6,' * ',' ','skipnt')
      dswhisto=.false.
      if (verbose) call writeinput(6,' * ',' ','dswhisto')
      writetop=.false.
      if (verbose) call writeinput(6,' * ',' ','writetop')
      writedat=.false.
      if (verbose) call writeinput(6,' * ',' ','writedat')
      writegnu=.false.
      if (verbose) call writeinput(6,' * ',' ','writegnu')
      writeroot=.false.
      if (verbose) call writeinput(6,' * ',' ','writeroot')

      if (verbose) write(6,*)
C      read(20,99) line
c--- write-out comment line
C      read(20,99) line
C      if (verbose) write(6,*) '* ',line
c--- general options 
c--- choose nrpoc=61(ww) or 81(zz)
      nproc=81
      
      if (verbose) call writeinput(6,' * ',' ','nproc')
      part='virt'
      if (verbose) call writeinput(6,' * ',' ','part')
      runstring='gg_zz'
      if (verbose) call writeinput(6,' * ',' ','runstring')
      sqrts=7d3
      if (verbose) call writeinput(6,' * ',' ','sqrts')
      ih1=1
      if (verbose) call writeinput(6,' * ',' ','ih1')
      ih2=1
      if (verbose) call writeinput(6,' * ',' ','ih2')
C      hmass=170d0
      if (verbose) call writeinput(6,' * ',' ','hmass')
      scale=80.398d0
      initscale=scale
      if (verbose) call writeinput(6,' * ',' ','scale')
      facscale=scale
      initfacscale=facscale
      if (verbose) call writeinput(6,' * ',' ','facscale')
      
      initrenscale_L=0d0
      initfacscale_L=0d0
      initrenscale_H=0d0
      initfacscale_H=0d0
c--- catch special scale choices for stop+b process

      dynstring='no' 
      if (verbose) call writeinput(6,' * ',' ','dynamicscale')
      zerowidth=.false.
      if (verbose) call writeinput(6,' * ',' ','zerowidth')
      removebr=.false.
      if (verbose) call writeinput(6,' * ',' ','removebr')
      itmx1=10
      if (verbose) call writeinput(6,' * ',' ','itmx1')
      ncall1=10000
      if (verbose) call writeinput(6,' * ',' ','ncall1')
      itmx2=10
      if (verbose) call writeinput(6,' * ',' ','itmx2')
      ncall2=10000
      if (verbose) call writeinput(6,' * ',' ','ncall2')
      origij=1089
      if (verbose) call writeinput(6,' * ',' ','ij')
      dryrun=.false.
      if (verbose) call writeinput(6,' * ',' ','dryrun')
      Qflag=.false.
      if (verbose) call writeinput(6,' * ',' ','Qflag')
      Gflag=.false.
      if (verbose) call writeinput(6,' * ',' ','Gflag')
      
      if (verbose) write(6,*)
C      read(20,99) line
c--- write-out comment line
C      read(20,99) line
C      if (verbose) write(6,*) '* ',line
c--- heavy quark masses 
C      mt=172.5d0
      if (verbose) call writeinput(6,' * ',' ','top mass')
C      mb=4.4d0
      if (verbose) call writeinput(6,' * ',' ','bottom mass')
C      mc=1.5d0
      if (verbose) call writeinput(6,' * ',' ','charm mass')

      if (verbose) write(6,*)
C      read(20,99) line
c--- write-out comment line
C      read(20,99) line
C      if (verbose) write(6,*) '* ',line
c--- pdf options 
      pdlabel='mstw8nl'
      if (verbose) call writeinput(6,' * ',' ','pdlabel')
      NGROUP=4
      if (verbose) call writeinput(6,' * ',' ','NGROUP')
      NSET=46
      if (verbose) call writeinput(6,' * ',' ','NSET')
      PDFname='cteq6mE.LHgrid'
      if (verbose) call writeinput(6,' * ',' ','LHAPDF group')
      PDFmember=-1
      if (verbose) call writeinput(6,' * ',' ','LHAPDF set')

      if (verbose) write(6,*)
C      read(20,99) line
c--- write-out comment line
C      read(20,99) line
C      if (verbose) write(6,*) '* ',line
c--- jets and cuts options 
      Mwmin=5d0
      if (verbose) call writeinput(6,' * ',' ','m34min')
      Mwmax=1d5 
      if (verbose) call writeinput(6,' * ',' ','m34max')
      mbbmin=5d0
      if (verbose) call writeinput(6,' * ',' ','m56min')
      mbbmax=1d5 
      if (verbose) call writeinput(6,' * ',' ','m56max')
      inclusive=.true.
      if (verbose) call writeinput(6,' * ',' ','inclusive')
      algorithm='ktal'
      if (verbose) call writeinput(6,' * ',' ','algorithm')
      ptjetmin=0d0
      if (verbose) call writeinput(6,' * ',' ','ptjetmin')
      etajetmin=0d0 
      if (verbose) call writeinput(6,' * ',' ','etajetmin')
      etajetmax=1d5
      if (verbose) call writeinput(6,' * ',' ','etajetmax')
      Rcut=0.7d0
      if (verbose) call writeinput(6,' * ',' ','Rcut')
      makecuts=.false.
      if (verbose) call writeinput(6,' * ',' ','makecuts')
      leptpt=0d0
      if (verbose) call writeinput(6,' * ',' ','leptpt')
      leptrap=1d5
      if (verbose) call writeinput(6,' * ',' ','leptrap')
      misspt=0d0
      if (verbose) call writeinput(6,' * ',' ','misspt')
      leptpt2=0d0
      if (verbose) call writeinput(6,' * ',' ','leptpt2')
      leptrap2=1d5
      if (verbose) call writeinput(6,' * ',' ','leptrap2')
      mtrans34cut=0d0
      if (verbose) call writeinput(6,' * ',' ','mtrans34cut')
      Rjlmin=0d0
      if (verbose) call writeinput(6,' * ',' ','Rjlmin')
      Rllmin=0d0
      if (verbose) call writeinput(6,' * ',' ','Rllmin')
      delyjjmin=0d0
      if (verbose) call writeinput(6,' * ',' ','delyjjmin')
      jetsopphem=.false. 
      if (verbose) call writeinput(6,' * ',' ','jetsopphem')
      lbjscheme=0 
      if (verbose) call writeinput(6,' * ',' ','lbjscheme')
      ptbjetmin=0d0
      if (verbose) call writeinput(6,' * ',' ','ptbjetmin')
      etabjetmax=1d5
      if (verbose) call writeinput(6,' * ',' ','etabjetmax')

      if (verbose) write(6,*)
C      read(20,99) line
c--- write-out comment line
C      read(20,99) line
C      if (verbose) write(6,*) '* ',line
c--- settings for photon processes 
      frag=.false.
      if (verbose) call writeinput(6,' * ',' ','frag')
      fragset='BFGsetII'
      if (verbose) call writeinput(6,' * ',' ','fragset')
      frag_scale=80d0
      if (verbose) call writeinput(6,' * ',' ','frag_scale')
      gammpt=10d0
      if (verbose) call writeinput(6,' * ',' ','gammpt')
      gammrap=5d0
      if (verbose) call writeinput(6,' * ',' ','gammrap')
      Rgalmin=0.7d0
      if (verbose) call writeinput(6,' * ',' ','Rgalmin')
      cone_ang=0.7d0
      if (verbose) call writeinput(6,' * ',' ','cone_ang')
      epsilon_h=0.15d0
      if (verbose) call writeinput(6,' * ',' ','epsilon_h')

      if (verbose) write(6,*)
C      read(20,99) line
c--- write-out comment line
C      read(20,99) line
C      if (verbose) write(6,*) '* ',line
c--- anomalous couplings 
      delg1_z=0.0d0
      if (verbose) call writeinput(6,' * ',' ','delg1_z')
      delk_z=0.0d0
      if (verbose) call writeinput(6,' * ',' ','delk_z')
      delk_g=0.0d0
      if (verbose) call writeinput(6,' * ',' ','delk_g')
      lambda_z=0.0d0
      if (verbose) call writeinput(6,' * ',' ','lambda_z')
      lambda_g=0.0d0
      if (verbose) call writeinput(6,' * ',' ','lambda_g')
      h1Z=0.0d0
      if (verbose) call writeinput(6,' * ',' ','h1Z')
      h1gam=0.0d0
      if (verbose) call writeinput(6,' * ',' ','h1gam')
      h2Z=0.0d0
      if (verbose) call writeinput(6,' * ',' ','h2Z')
      h2gam=0.0d0
      if (verbose) call writeinput(6,' * ',' ','h2gam')
      h3Z=0.0d0
      if (verbose) call writeinput(6,' * ',' ','h3Z')
      h3gam=0.0d0
      if (verbose) call writeinput(6,' * ',' ','h3gam')
      h4Z=0.0d0
      if (verbose) call writeinput(6,' * ',' ','h4Z')
      h4gam=0.0d0
      if (verbose) call writeinput(6,' * ',' ','h4gam')
      tevscale=2.0d0
      if (verbose) call writeinput(6,' * ',' ','tevscale')

      if (verbose) write(6,*)
C      read(20,99) line
c--- write-out comment line
C      read(20,99) line
C      if (verbose) write(6,*) '* ',line
c--- grid information 
      readin=.false.
      if (verbose) call writeinput(6,' * ',' ','readin')
      writeout=.false.
      if (verbose) call writeinput(6,' * ',' ','writeout')
      ingridfile=''
      if (verbose) call writeinput(6,' * ',' ','ingridfile')
      outgridfile=''
      if (verbose) call writeinput(6,' * ',' ','outgridfile')

      if (verbose) write(6,*)

c--- check if the contents of technical.DAT are included here
c--- (the default behaviour going forward)
      technicalincluded=.false.

C      read(20,99,end=88) line
C      read(20,99,end=88) line
c      write(6,*) line
C      if (line(2:10) .ne. 'Technical') goto 88
      technicalincluded=.true.

C   88 continue
      
c--- if the contents of technical.DAT are not included, close the input
c--- file and open technical.DAT instead; otherwise continue on
C      if (technicalincluded .eqv. .false.) then
C        close(20)
C        open(unit=20,file='technical.DAT',status='old',err=999)
C        call checkversion(20,'technical.DAT')
C      endif

      if (verbose) write(6,*) '* [Technical parameters that'//
     .                        ' should not normally be changed]'
      if (verbose) write(6,*)

c---- read-in the technical parameters

      debug=.false.
      if (verbose) call writeinput(6,' * ',' ','debug')
      verbose=.true.
      if (verbose) call writeinput(6,' * ',' ','verbose')
      new_pspace=.false.
      if (verbose) call writeinput(6,' * ',' ','new_pspace')
      virtonly=.false.
      if (verbose) call writeinput(6,' * ',' ','virtonly')
      realonly=.false.
      if (verbose) call writeinput(6,' * ',' ','realonly')
      spira=.true.
      if (verbose) call writeinput(6,' * ',' ','spira')
      noglue=.false.
      if (verbose) call writeinput(6,' * ',' ','noglue')
      ggonly=.true.
      if (verbose) call writeinput(6,' * ',' ','ggonly')
      gqonly=.false.
      if (verbose) call writeinput(6,' * ',' ','gqonly')
      omitgg=.false.
      if (verbose) call writeinput(6,' * ',' ','omitgg')
      vanillafiles=.false.
      if (verbose) call writeinput(6,' * ',' ','vanillafiles')
      nmin=1
      if (verbose) call writeinput(6,' * ',' ','nmin')
      nmax=2
      if (verbose) call writeinput(6,' * ',' ','nmax')
      clustering=.true.
      if (verbose) call writeinput(6,' * ',' ','clustering')
      realwt=.false.
      if (verbose) call writeinput(6,' * ',' ','realwt')
      colourchoice=0
      if (verbose) call writeinput(6,' * ',' ','colourchoice')
      rtsmin=1d-2
      if (verbose) call writeinput(6,' * ',' ','rtsmin')
      cutoff=1d-4
      if (verbose) call writeinput(6,' * ',' ','cutoff')
      aii=1d0
      if (verbose) call writeinput(6,' * ',' ','aii')
      aif=1d0
      if (verbose) call writeinput(6,' * ',' ','aif')
      afi=1d0
      if (verbose) call writeinput(6,' * ',' ','afi')
      aff=1d0
      if (verbose) call writeinput(6,' * ',' ','aff')
      bfi=1d0
      if (verbose) call writeinput(6,' * ',' ','bfi')
      bff=1d0
      if (verbose) call writeinput(6,' * ',' ','bff')
      if (verbose) write(6,*)
C      close(unit=20)

      if ((etajetmin .lt. 0d0) .or. (etajetmax .lt. 0d0)) then
        write(6,*) 'etajetmin and etajetmax are absolute values,'
	write(6,*) ' please reset to a positive value.'
	stop
      endif

      
c---  create logical variable dynamicscale for use in other routines
      if (  (dynstring .eq. 'no') .or. (dynstring .eq. '.false.')
     & .or. (dynstring .eq. 'none') ) then 
         dynamicscale=.false. 
      else
         dynamicscale=.true. 
      endif

c--- print warning messages if some parton fluxes are not included      
      if (noglue) then
        write(6,*) 'WARNING: no gluon contribution included in PDF'
	write(6,*)
      endif
      if (ggonly) then
        write(6,*) 'WARNING: only gluon-gluon flux included'
	write(6,*)
      endif
      if (gqonly) then
        write(6,*) 'WARNING: only gluon-quark flux included'
	write(6,*)
      endif
      if (omitgg) then
        write(6,*) 'WARNING: no gluon-gluon contribution included'
	write(6,*)
      endif
      
c--- assign squared masses for b- and c-quarks
      if (abs(mb) .gt. 1d-8) then
        mbsq=mb**2
      else
        mbsq=4.75d0**2
      endif
      if (abs(mc) .gt. 1d-8) then
        mcsq=mc**2
      else
        mcsq=1.5d0**2
      endif
      
c--- set-up mass window cuts
      bbsqmin=mbbmin**2
      bbsqmax=mbbmax**2

      wsqmin=Mwmin**2
      wsqmax=Mwmax**2

      write(*,*) 'mass window cuts : ',bbsqmin,bbsqmax,wsqmin,wsqmax


c--- set-up the variables for the process we wish to consider
      call chooser

c--- set-up the random number generator with a negative seed
      idum=-abs(origij)
      randummy=ran2()

c--- initialize masses for alpha_s routine
      cmass=dsqrt(mcsq)
      bmass=dsqrt(mbsq)

c--- E-M gauge invariance requires that delg1_g=0
      delg1_g=0d0

c--- check that we have a valid value of 'part'

c--- set up the default choices of static scale, if required
c--- special cases where Higgs mass is neither mass2 nor mass3
c--- special case for t-tbar production
c--- special cases where Higgs mass is neither mass2 nor mass3
c--- special case for t-tbar production
      return

   49 format(' *  ',a20,f12.8,16x,'*')
   50 format(' *  ',6x,a8,i1,a25,8x,'*')
   76 format(' *      Renormalization scale =',f7.2,'              *')   
   77 format(' *        Factorization scale =',f7.2,'              *')   
   99 format(a90)

  999 continue
      write(6,*) 'Problem reading ',inputfile
      write(6,*)
      write(6,*) 'Refer to documentation for the format of input.DAT'
      write(6,*)
      stop

      end
      
